# Script to start ssh tunnel to DPV
# ERROR cases:
# 255 - DPV not found or unavailable
# 1 - tunnel could not be establish (check syntax)
# If the tunnel was already up, there will be no error reported



. /etc/default/bp.ini 2> /dev/null

SyncTo=`$BPDIR/bin/bputil -g ExchangeSecuresync SyncTo "" $BPDIR/bpinit/master.ini`

Transport=`$BPDIR/bin/bputil -g ExchangeSecuresync TransportType "" $BPDIR/bpinit/master.ini`

SyncUser=`$BPDIR/bin/bputil -g ExchangeSecuresync SyncUser "" $BPDIR/bpinit/master.ini`

loc_ret=0

#check if the transport type is ssh
if [ !  "$Transport" = "ssh" ]
then
				exit $loc_ret
fi

#echo $SyncTo

DPV=`echo $SyncTo | cut -d: -f1`
#echo $DPV


ssh -f -o BatchMode=yes -L 5555:localhost:5432					\
				-l $SyncUser $DPV 'sleep 30 && exit 0' 2> /dev/null

loc_ret=$?
if [ $loc_ret -ne 0 ]
then
	echo "data_tunnel_up.sh: ERROR: tunnel not up,  failed with error $loc_ret." 
	echo "data_tunnel_up.sh: Make sure that user $SyncUser exists on $DPV."
	exit $loc_ret
fi
exit $loc_ret
