#!/usr/bin/php
<?php

/* Detect and fix any events with negative dtstart values */

$conn_str = "port=5432 dbname=bpdb user=postgres connect_timeout=30";

/* DB connection */
$conn = pg_connect($conn_str);
if ($conn === false) {
	print "Could not connect to the database.\n";
	exit(1);
}
$bpdir = trim(shell_exec('eval `grep BPDIR /etc/default/bp.ini`; echo $BPDIR'));

$query = "SELECT event_id, dtstart FROM bp.events WHERE dtstart < 0";
$res = pg_query($conn, $query);
if ($res == false) {
	echo "Failed to query for negative dtstart events.\n";
	exit(1);
}

$nRows = pg_num_rows($res);
echo "Found $nRows event(s) with negative dtstart events.\n";
$failed = false;

while ($row = pg_fetch_assoc($res)) {
	$event_id = $row["event_id"];
	$oldval = $row["dtstart"];
	$hr_min =  date('H:i', $oldval);
	$newval =  strtotime($hr_min);
	$newval -= 86400;
	$q2 = "UPDATE bp.events SET dtstart = $newval WHERE event_id = $event_id";
	$r2 = pg_query($conn, $q2);
	if ($r2 == false) {
		echo "Failed to update dtstart for event_id $event_id.\n";
		$failed = true;
	}
	else {
		echo "Updated dtstart from $oldval to $newval for event_id $event_id.\n";
	}
}
if ($failed == false) {
	$q = "UPDATE bp.operation_status SET status = 'done' WHERE operation_id=10";
	$r3 = pg_query($conn, $q);
	if ($r3 == false) {
		echo "Failed to finalize operation_status for ID 10.\n";
		exit(1);
	}
	else {
		echo "Updated operation_status for ID 10 as done.\n";
		if ($nRows > 0) {
			echo "Signaling tasker to re-read the configuration.\n";
			shell_exec("$bpdir/bin/dispatch reset");
		}
		exit(0);
	}
}
else {
	echo "Failures occurred, operation_status was not updated as done.\n";
	exit(1);
}

?>
