<?php

// This file can be included (or required) in PHP scripts to define a
// function for sending email reports.  See the PHP manual for
// documentation of "include" and "require" for how to use it. In order
// for this file to be interpreted as code to be executed (instead of as
// HTML), it must start and end with valid PHP start/end tags.

function mail_report($from, $to, $subject, $report, $images, $pdfFullFilename = false) {

	$boundary = md5(uniqid(time()));

	$email = 'From: ' . $from . "\n";
	$email .= 'To: ' . $to . "\n";
	$email .= 'Return-Path: ' . $from . "\n";
	$email .= 'MIME-Version: 1.0' . "\n";
	$email .= 'Content-Type: multipart/mixed; boundary="' . $boundary . '"' . "\n\n";

	$email .= "Please enable HTML to view this report.\n\n";
	$email .= '--' . $boundary . "\n";

	$email .= 'Content-Type: text/HTML; charset=ISO-8859-1' . "\n";
	$email .= 'Content-Transfer-Encoding: 7bit' . "\n\n";

	$email .= $report . "\n";

	foreach($images as $image) {
		$email .= '--' . $boundary . "\n";
		// Open as reading a binary
		$fd = fopen($image["filename"], "rb");
		$contents = fread($fd, filesize($image["filename"]));
		fclose($fd);

		$cid = $image["cid"];

		$email .= 'Content-ID: <' . $image["cid"] . ">\n";
		$email .= 'Content-Type: image/' . $image["type"] . ";\n";

		// The optional "attach" index gives a name for attaching
		// the image as a file.
		if (isset($image["attach"]) && !empty($image["attach"])) {
			$email .= 'Content-Disposition: attachment; ';
			$email .= 'filename=' . $image["attach"] . ";\n";
		}
		$email .= 'Content-Transfer-Encoding: base64' . "\n\n";
		// Use chunk_split (RFC 2045)
		$email .= chunk_split(base64_encode($contents)) . "\n\n";
	}
	
	// send PDF as an attachment if specified
	if ($pdfFullFilename !== false && file_exists($pdfFullFilename)) {
		$eol = "\n";
    	$attachment = chunk_split(base64_encode(file_get_contents($pdfFullFilename)));
		$pdfFilename = basename($pdfFullFilename);
		$email .= '--' . $boundary . $eol;
		$email .= "Content-Type: application/pdf; name=\"" . $pdfFilename . "\"" . $eol; 
		$email .= "Content-Transfer-Encoding: base64" . $eol;
		$email .= "Content-Disposition: attachment; filename=\"" . $pdfFilename . "\"" . $eol . $eol;
		$email .= $attachment . $eol . $eol;
	}

	$email .= '--' . $boundary . "--\n";
	$mail_status = mail('', $subject,'',$email);
	return $mail_status;
}
?>

