#!/usr/bin/php 

<?php

#--------------------------------------------------------------
# Function Name: build_html
# Prototype: build_html([string]notification, [string]dpuName, [string]assetTag)
# Must include("notification_wrapper.php")
# Can also be run from Command Line as Script.  Outputs HTML Content
# Prototype: ./php notification_wrapper.php <Notification Text>; <System Name>; <Asset Tag>
# Purpose: Wrap a notification in visually friendly HTML to email.
# Creator: jscott
#--------------------------------------------------------------

	error_reporting(0);

	if(isset($argv[1])){
		$fcontents = file($argv[1]);
		$finfo = stat($argv[1]);
		
		$dpuName = $fcontents[0];
		$assetTag = $fcontents[1];
		
		$notification_body = null;
		foreach ($fcontents as $i=>$elem){
			if($i > 1){
				$notification_body .= $elem . "<br />";
			}
		}
		$temp = buildHTML($notification_body, $dpuName, $assetTag);
		echo $temp;
		flush();
	}
	
	
	
	
	
function build_header(){
	$header = '<html><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml">' . "\n" . '<head>' . "\n" . ' ';
	$header .= '<meta type="text/css"></meta>';
	$header .= '<title>Unitrends Enterprise Backup Notification</title>' . "\n";
	$header .= '</head>';
	
	return $header;
}

function build_body($notificationText, $dpuName, $assetTag){
	$body = '	<body>' . "\n";
	$body .= ' <div align="center">' . "\n";
	
	
	$body .= build_table($notificationText, $dpuName, $assetTag);	
	$body .= '	</div>' . "\n" . '</body>' . "\n" . '</html>' . "\n";
	return $body;
}

function build_table($notificationText, $dpuName, $assetTag){
	$table = null;
	$table .= '		<table style="border:0;border-collapse:collapse;border-spacing:0;width:720px;" width="720px" cellpadding="0" cellspacing="0">'. "\n";
	$table .= '			<tr style="border:0;"> ' . "\n";
	$table .= '					<td style="border:0;padding:3em 2em;"> ' . "\n";
	$table .= '						<img src="http://www.unitrends.com/reports/color/logo.png" float="left">' . "\n";
	$table .= ' 				</td>' . "\n";
	$table .= '					<td style="border:0;padding-right:2em;"> ' . "\n";
	$table .= '						<p style="color:#999;font-family: Calibri, Candara, Segoe, \'Segoe UI\', Optima, Arial, sans-serif;font-size:80%; text-align:right;">'; 
	$table .=  ' &nbsp;</p>' . "\n";
	$table .= ' 				</td>' . "\n";
	$table .= '			</tr>';
	$table .= '			<tr> ' . "\n";
	$table .= '					<td style="border:0px;"border="0px"colspan="2"> ' . "\n";
	$table .= '						<img src="http://www.unitrends.com/reports/notifications/roundedrectangletop.png" width="720" height="26" style="height:100%;width:100%;vertical-align:bottom;margin:0px 0px -2px;padding:0px;float:left;">' . "\n";
	$table .= ' 				</td>' . "\n";
	$table .= '			</tr>' . "\n";
	$table .= '			<tr> ' . "\n";
	$table .= '				<td bgcolor=\"#999999\" style="background-color:#999999;text-align:left;padding-left:2em; padding-bottom:1em;"colspan="2"> ' . "\n";
	$table .= '					<p style="color:#222222;font-family: Calibri, Candara, Segoe, \'Segoe UI\', Optima, Arial, sans-serif;text-align:left;"> <strong>Notification for ' . $dpuName . '</strong></p>' . " \n";
	$table .= '				</td> ' . "\n";
	$table .= '			</tr>' . "\n";		
	$table .= '			<tr>' . "\n";
	$table .= '					<td style="border:1px solid #999999;padding:4em;" colspan="2"> ' . "\n";
	$table .= ' 					<p style="color:#555555;font-family: Calibri, Candara, Segoe, \'Segoe UI\', Optima, Arial, sans-serif;text-align:left;font-size:75%;word-spacing:1px;"> ' . $notificationText . '</p>' . "\n";
	$table .= '					</td>' . "\n";
	$table .= '			</tr>' . "\n";
	$table .= '			<tr style="border:0;">' . "\n";
	$table .= '				<td style ="padding:2em;"> ' . "\n";
	$table .= '					<p style="color:#555555;font-family: Calibri, Candara, Segoe, \'Segoe UI\', Optima, Arial, sans-serif;text-align:left;font-size:80%;word-spacing:1px;"> ' . "\n";
	$table .= '						Asset Tag: ' . $assetTag . '</p>' . "\n";
	$table .= '					<p style="color:#555555;font-family: Calibri, Candara, Segoe, \'Segoe UI\', Optima, Arial, sans-serif;text-align:left;font-size:80%;word-spacing:1px;"> ' . "\n";
	$table .= '						Notification generated: ' . date("F j, Y, g:i a") . "\n";
	$table .= '					</p>' . "\n";
	$table .= '					<p style="color:#555555;font-family: Calibri, Candara, Segoe, \'Segoe UI\', Optima, Arial, sans-serif;text-align:left;font-size:80%;word-spacing:1px;"> ' . "\n";
	$table .= '						Notification preferences can be set through the user interface via <strong>Settings -> Clients, Networking and Notifications</strong>' . "\n";
	$table .= '					</p>' . "\n";
	$table .= '					<p style="color:#555;font-family: Calibri, Candara, Segoe, \'Segoe UI\', Optima, Arial, sans-serif;text-align:left;font-size:80%;word-spacing:1px;"> ' . "\n";
	$table .= '						Additional resources are available at the following:' . "\n";
	$table .= '					</p>';
	$table .= '						<ul style="display:block;">' . "\n";
	$table .= '							<li style="color:#555;font-family: Calibri, Candara, Segoe, \'Segoe UI\', Optima, Arial, sans-serif;text-align:left;font-size:80%;word-spacing:1px;"><a href="http://www.unitrends.com/documents/appliance-agent-user-manual.pdf">Manual</a></li>' . "\n";
	$table .= '							<li style="color:#555;font-family: Calibri, Candara, Segoe, \'Segoe UI\', Optima, Arial, sans-serif;text-align:left;font-size:80%;word-spacing:1px;"><a href="http://support.unitrends.com/ikm/">Knowledge Base</a></li>' . "\n";
	$table .= '							<li style="color:#555;font-family: Calibri, Candara, Segoe, \'Segoe UI\', Optima, Arial, sans-serif;text-align:left;font-size:80%;word-spacing:1px;"><a href="http://www.unitrends.com/support/customer-care-center/video-tutorials.html">Training Videos</a></li>' . "\n";
	$table .= '						</ul>' . "\n";
	$table .= '				</td>' . "\n";
	$table .= '				<td style = "padding:2em;"> ' . "\n";
	$table .= '					<p style="color:#555;font-family: Calibri, Candara, Segoe, \'Segoe UI\', Optima, Arial, sans-serif;text-align:left;font-size:80%;word-spacing:1px;"> Connect with us. <br />' . "\n";
	$table .= '						<a href="http://community.spiceworks.com/pages/unitrends"><img float="right"src="http://www.unitrends.com/reports/spiceworks.jpg"';
	$table .= '						border="0" alt="Spiceworks" width="42" height="42" style="margin: 3px 3px 0px 3px;" /></a><a href="http://www.facebook.com/unitrends"><img float="right"src="http://www.unitrends.com/reports/facebook.jpg" border="0"alt="Be our friends on Facebok" width="42" height="42" style="margin:';
	$table .= ' 					3px 3px 0px 3px;" /></a><br /><a href="http://www.linkedin.com/company/25406?trk=tyah"><img float="right"src="http://www.unitrends.com/reports/linkd-in.jpg" border="0" alt="Linked In"width="42" height="42" style="margin: 3px 3px 0px 3px;" /></a><a href="http://twitter.com/#!/Unitrends"><img float="right"src="http://www.unitrends.com/reports/twitter.jpg" border="0" alt="Twitter" width="42" height="42" ';
	$table .= '						style="margin: 3px 3px 0px 3px;" /></a><a href="http://www.youtube.com/user/UnitrendsInc"><img float="right"src="http://www.unitrends.com/reports/you-tube.jpg" border="0"alt="You Tube" width="42" height="42" style="margin: 3px 3px 0px 3px;" /></a>' . "\n";
	$table .= '					</p>';
	$table .= '			</tr>' . "\n";
	$table .= '		</table>' ." \n";
	
	return $table;
	
	
}
function buildHTML($notificationText, $dpuName, $assetTag){

	$page = build_header() . build_body($notificationText, $dpuName, $assetTag);
	$fp = fopen("test.html", "w", 0);

	fwrite($fp, $page);
	flush();
	return build_header() . build_body($notificationText,$dpuName,$assetTag);
	
}

?>
