#!/usr/bin/php 
<?php

# Change log
## Bug   Who  Description
## ---   ---  -----------
## 16107 WP   Created for disk_monitoring_logger.py to send alerts, traps, logs through existing PHP library
##            Also this will be used for future python script


$change = 0;
$notification_id = -1;
$target ="";
$sentence = "";

# Description of option tags for this script
if($argc < 9 && $argv[1] != "-c") {
  echo "Usage: ".basename($argv[0])." -c <code> -n <trapNumber> -t <targetKeyword> -s <stringMessage> -o \n";
  echo "   -c <code>          (0) close it (1) either open new one, reopen the closed one, or update it\n";
  echo "   -n <trapNumber>    notification_id in [notifications] table\n";
  echo "   -t <targetKeyword> second message (1.1.2) in trap\n";
  echo "   -s <stringMessage> third message  (1.1.3) in trap\n";
  die;
} else {
  for ($i = 1; $i < $argc; $i++)  {
    switch ($argv[$i]) {
    case '-c':
      $change = (int) $argv[++$i];
      break;
    case '-n':
      $notification_id = (int) $argv[++$i];
      break;
    case '-t':
      $target = $argv[++$i];
      break;
    case '-s':
      $sentence = $argv[++$i];
      break;
    }
  }
 }

# closing established alerts
if ($change == 0) { 
  bp_send_notification($notification_id, $target); # notification_id 139 would internal notifications
# either open new alert, reopen the closed one, or update it
 } else { 
  bp_send_notification($notification_id, $target, $sentence);
 }
 
?>
