<?php

class Networks
{
    private $BP;
	private $sid;
     
    public function __construct($BP, $sid)
    {
		$this->BP = $BP;
		$this->sid = $sid;
    }
 
    public function get($which, $filter, $data, $sid) {
        $systemID = isset($_GET['sid']) ? (int)$_GET['sid'] : $this->BP->get_local_system_id();
        $secondFilter=$filter[2];
        switch($which){
            case "bridge":
                //check if nic is provided (Eg: eth0,eth1 and so on)
                if($secondFilter[0]=="e"){
                    $Bridge=$this->BP->get_nic_bridge($secondFilter,$systemID);
                    $networkList=array('bridge' => $Bridge ? $Bridge : "");
                }
                //Else if just systemID is provided
                else{
                    $Bridge=$this->BP->get_virtual_bridge($systemID);
                    if(isset($Bridge)){
                        $networkList['bridge']=$Bridge[0];
                        for($i=1;$i<count($Bridge);$i++){
                            $nics[]=$Bridge[$i];
                        }
                        $networkList['nics']=$nics;
                    }
                }
                break;

            case "virtual_bridge":
                $systemID = $this->BP->get_local_system_id();
                $virtualBridge=$this->BP->get_virtual_bridge_network($systemID);
                $bridgedata=array(
                                'network'=>$virtualBridge['NETWORK'],
                                'netmask'=>$virtualBridge['NETMASK'],
                                'gateway'=>$virtualBridge['GATEWAY'],
                                'dhcprange'=>$virtualBridge['DHCPRANGE'],
                                'message'=>"",
                                );
                $networkList=array('bridge'=>$bridgedata);
                break;

            case "hypervisor-switch":
                if (isset($data['hypervisor_type'])) {
                    $hypervisor_type = $data['hypervisor_type'] . ' host';
                    if (isset($data['hypervisor'])) {
                        $hypervisor = $data['hypervisor'];
                        $switches = $this->BP->get_hypervisor_network_switches($hypervisor_type, $hypervisor, $systemID);
                        if ($switches !== false) {
                            foreach ($switches as $switch) {
                                $networkList['names'][] = $switch;
                            }
                        } else {
                            $networkList = $switches;
                        }
                    } else {
                        $networkList['error'] = 500;
                        $networkList['message'] = "The hypervisor name is to be specified.";
                        break;
                    }
                } else {
                    $networkList['error'] = 500;
                    $networkList['message'] = "The type of the hypervisor is to be specified.";
                }
                break;

            default:
                $networks = $this->BP->get_network_list($this->sid);
                $networkList = array();

                if ($networks === false) {
                    ;  //do what?  message?
                } else {
                    foreach ($networks as $network) {
                        $dns = array();
                        $search = array();
                        $networkName = $network;
                        $networkInfo = $this->BP->get_network_info($networkName, $this->sid);

                        $dnsList = $this->BP->get_dns_list($this->sid);
                        if ($dnsList !== false) {
                            $searchList = $this->BP->get_dns_search_list($this->sid);
                            if ($searchList !== false){
                                foreach ($dnsList as $dnsIP) {
                                    $dns[] = $dnsIP;

                                }

                                foreach ($searchList as $dnsDomain){
                                    $search[] = $dnsDomain;

                                }
                                $search = implode(', ', $search);
                            }
                        }
                        $data = $this->buildOutput($networkName, $networkInfo, $dns, $search);
                        $list[] = $data;
                    }
                    $networkList['networks'] = $list;

                }
                break;
        }


        return $networkList;

    }

    public function update($which,$filter, $inputArray,$sid){
        $dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $this->BP->get_local_system_id();

        switch($which){

            case "virtual_bridge":
                if($inputArray['network']!==NULL){
                    $result=$this->BP->set_virtual_bridge($inputArray['network'], $dpuID);
                }
                break;

            //GET/api/networks/eth0 or eth1 etc.

            default:

                if(!$inputArray) {
                    return false;
                }
                $currentNetworkInfo = $this->BP->get_network_info($which,$dpuID);

                if(isset($inputArray['ip'])){
                    $currentNetworkInfo['ip'] = $inputArray['ip'];
                }
                if(isset($inputArray['netmask'])){
                    $currentNetworkInfo['netmask'] = $inputArray['netmask'];
                }
                if(isset($inputArray['gateway'])){
                    $currentNetworkInfo['gateway'] = $inputArray['gateway'];
                }
                if(!isset($inputArray['auto_restore'])){                                        //Auto restore is disabled. Check with Linda about this.
                    $currentNetworkInfo['auto_restore'] = false;
                }
                $saveNetworkInfoResult = $this->BP->save_network_info($currentNetworkInfo, $dpuID);
                if($saveNetworkInfoResult === false){
                    return false;
                }


                if (isset($inputArray['dns1'])){
                    $DNSInfo[0] = $inputArray['dns1'];
                    if(isset($inputArray['dns2']) and $inputArray['dns2'] !== ""){
                        $DNSInfo[1] = $inputArray['dns2'];
                    }
                    $saveDNSInfoResult = $this->BP->save_dns_list($DNSInfo,$dpuID);
                } else if(isset($inputArray['dns'])){
                    $DNSInfo = $inputArray['dns'];
                    $saveDNSInfoResult = $this->BP->save_dns_list($DNSInfo,$dpuID);
                }
                if($saveDNSInfoResult === false){
                    return false;
                }


                //$searchList=$this->BP->get_dns_search_list($dpuID);
                if(isset($inputArray['search'])){
                    $input = str_replace(" ", "", $inputArray['search']);
                    $searchList = explode(",", $input);
                    $saveDNSSearchResult = $this->BP->save_dns_search_list($searchList,$dpuID);
                }
                if($saveDNSSearchResult === false){
                    return false;
                }
                break;
        }


        return $result;

    }

    public function post($which, $inputArray, $sid) {
        $dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $this->BP->get_local_system_id();
        if($which=="bridge"){
            $bridge=$this->BP->add_virtual_bridge($inputArray['nic'],$dpuID);
        }
        $output['id'] = $bridge;
        $result = array('result' => $output);
        return $result;
    }

    function validateIP($ip){
        return inet_pton($ip) !== false;
    }

    public function delete($which,$filter,$sid)
    {
        $data = null;
        if ($which == "bridge"){
            if (isset($filter[2])) {
                $nic = $filter[2];
                $sid = $sid === false ? $this->BP->get_local_system_id() : $sid;
                if (isset($_GET['bridge'])) {
                    $bridge = $_GET['bridge'];
                    $data=$this->BP->delete_virtual_bridge($nic, $bridge, $sid);
                } else {
                    $data = array();
                    $data['error'] = 500;
                    $data['message'] = 'Bridge name must be specified when deleting a bridge.';
                }
            } else {
                $data = array();
                $data['error'] = 500;
                $data['message'] = 'Network interface name must be specified when deleting a bridge.';
            }
        }
        return $data;
    }

    function buildOutput($networkName, $networkInfo, $dns, $search) {

        $ip = isset($networkInfo['ip']) ? $networkInfo['ip'] : null;
        $netmask = isset($networkInfo['netmask']) ? $networkInfo['netmask'] : null;
        $gateway = isset($networkInfo['gateway']) ? $networkInfo['gateway'] : null;
        $boot = isset($networkInfo['boot']) ? $networkInfo['boot'] : null;
        $link = isset($networkInfo['link']) ? $networkInfo['link'] : null;
        $speed = isset($networkInfo['speed']) ? $networkInfo['speed'] : null;
        $duplex = isset($networkInfo['duplex']) ? $networkInfo['duplex'] : null;
        $MAC = isset($networkInfo['hwaddr']) ? trim($networkInfo['hwaddr'], '"') : null;


        $data = array(
            'id' => $networkName,
            'name' => $networkName,
            'dns' => $dns,
            'dns1' => $dns[0],
            'dns2' => $dns[1],
            'search' => $search,
            'ip' => $ip,
            'netmask' => $netmask,
            'gateway' => $gateway,
            'mac' => $MAC,
            'boot' => $boot,
            'link' => $link,
            'speed' => $speed,
            'duplex' => $duplex
        );

        return $data;
    }
} // end Networks class




?>
