<?php

$dir = '/api/includes/reports';

class AuditHistoryReport
{
    private $BP;

    public function __construct( $BP, $functionsClass )
    {
        $this->BP = $BP;
        $this->functions = $functionsClass;
    }

    public function get_audit_history($systems, $data)
    {
        $report = array();
        $report_count = 0;
        //Temporary until more data is available
        $report_total = $report_count;
        $report_start = 1;
        $report_data = array();

        $start_time = false;
        if (array_key_exists('start_date', $data))
        {
            $start_time = strtotime($data['start_date']);
        }
        $end_time = false;
        if (array_key_exists('end_date', $data))
        {
            $end_time = $this->functions->formatEndDate($data['end_date']);
        }

        $isValidDate = $this->functions->isValidDateRange($start_time, $end_time, false);

        if($isValidDate) {
            foreach ($systems as $system_id => $system_name)
            {
                $audit_history_result_format = array();
                $audit_history_result_format['dpu'] = $system_id;

                if ($start_time !== false)
                {
                    $audit_history_result_format['start_time'] = $start_time;
                }
                if ($end_time !== false)
                {
                    $audit_history_result_format['end_time'] = $end_time;
                }

                $audit_history = $this->BP->get_audit_history($audit_history_result_format, $system_id);

                if($audit_history !== false)
                {
                    foreach ( $audit_history as $audit_history_entry )
                    {

                        //$temp_data_array = array();
                        //$temp_data_array['notification_id'] = $audit_history_entry['notification_id'];
                        //$temp_data_array['event_time'] = date(Constants::DATE_FORMAT_US, $audit_history_entry['event_time']);
                        /*$temp_data_array['username'] = $audit_history_entry['username'];
                        $temp_data_array['system_name'] = $audit_history_entry['system'];
                        $temp_data_array['message'] = $audit_history_entry['message'];
                        $temp_data_array['category'] = $audit_history_entry['category'];*/

                        $audit_history_entry['event_time'] = date(Constants::DATE_TIME_FORMAT_US, strtotime($audit_history_entry['event_time']) );

                        $report_data[] = $audit_history_entry;
                        $report_count += 1;
                    }
                }
                else
                {

                    //$report_data[] = $this->BP->getError();
                }
                /*else
                {
                    $report = false;
                }*/
            }
            $report_total = $report_count;  //Temporary

            $report['count'] = $report_count;
            $report['total'] = $report_total;
            $report['start'] = $report_start;
            $report['data'] = $report_data;
        } else {
            $report['error'] = 500;
            $report['message'] = "Invalid date range provided";
        }
        return $report;
    }

}