<?php

$dir = '/api/includes/reports';

class bpGetBackupStatusReports
{
    private $BP;

    public function __construct( $BP, $functionsClass )
    {
        $this->BP = $BP;
        $this->functions = $functionsClass;
    }

    public function get_backup_history_report( $systems, $data, $filter = null )
    {
        $report = array();
        $report_count = 0;
        //Temporary until more data is available
        $report_total = $report_count;
        $report_start = 1;
        $report_data = array();


        $start_time = false;
        if ( array_key_exists('start_date', $data) )
        {
            $start_time = strtotime($data['start_date']);
        }
        $end_time = false;
        if ( array_key_exists('end_date', $data) )
        {
            $end_time = $this->functions->formatEndDate($data['end_date']);
        }

        $isValidDate = $this->functions->isValidDateRange( $start_time, $end_time, false);

        if($isValidDate) {
            foreach ($systems as $system_id => $system_name)
            {
                $clients = $this->BP->get_client_list($system_id);

                $backup_status_result_format = array();
                $backup_status_result_format['system_id'] = $system_id;
                $backup_status_result_format['type'] = array( Constants::BACKUP_TYPE_MASTER,
                    Constants::BACKUP_TYPE_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_INCREMENTAL,
                    Constants::BACKUP_TYPE_BAREMETAL,
                    Constants::BACKUP_TYPE_SELECTIVE,
                    Constants::BACKUP_TYPE_MSSQL_FULL,
                    Constants::BACKUP_TYPE_MSSQL_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_MSSQL_TRANSACTION,
                    Constants::BACKUP_TYPE_EXCHANGE_FULL,
                    Constants::BACKUP_TYPE_EXCHANGE_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_EXCHANGE_INCREMENTAL,
                    Constants::BACKUP_TYPE_LEGACY_MSSQL_FULL,
                    Constants::BACKUP_TYPE_LEGACY_MSSQL_DIFF,
                    Constants::BACKUP_TYPE_LEGACY_MSSQL_TRANS,
                    Constants::BACKUP_TYPE_VMWARE_FULL,
                    Constants::BACKUP_TYPE_VMWARE_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_VMWARE_INCREMENTAL,
                    Constants::BACKUP_TYPE_HYPER_V_FULL,
                    Constants::BACKUP_TYPE_HYPER_V_INCREMENTAL,
                    Constants::BACKUP_TYPE_HYPER_V_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_ORACLE_FULL,
                    Constants::BACKUP_TYPE_ORACLE_INCR,
                    Constants::BACKUP_TYPE_SHAREPOINT_FULL,
                    Constants::BACKUP_TYPE_SHAREPOINT_DIFF,
                    //Constants::BACKUP_TYPE_SYSTEM_METADATA,
                    Constants::BACKUP_TYPE_UCS_SERVICE_PROFILE_FULL,
                    Constants::BACKUP_TYPE_NDMP_FULL,
                    Constants::BACKUP_TYPE_NDMP_DIFF,
                    Constants::BACKUP_TYPE_NDMP_INCR,
                    Constants::BACKUP_TYPE_XEN_FULL );

                    if($start_time !== false) {
                        $backup_status_result_format['start_time'] = $start_time;
                    }
                    if($end_time !== false) {
                        $backup_status_result_format['end_time'] = $end_time;
                    }
                    /*  Not needed for first out
                    if ( array_key_exists('client_id', $data) )
                    {
                        $backup_status_result_format['client_id'] = $data['client_id'];
                    }*/
                    $backup_status_result_format['grandclients'] = false; //check this
                    /* Not needed for first out
                    if ( array_key_exists('backup_ids', $data) )
                    {
                        $backup_status_result_format['backup_ids'] = $data['backup_ids'];
                    }
                    if ( array_key_exists('sync_msg', $data) )
                    {
                        $backup_status_result_format['sync_msg'] = $data['sync_msg'];
                    }
                    if ( array_key_exists('finish_interval_start', $data) )
                    {
                        $backup_status_result_format['finish_interval_start'] = $data['finish_interval_start'];
                    }
                    if ( array_key_exists('Finish_interval_end', $data) )
                    {
                        $backup_status_result_format['Finish_interval_end'] = $data['Finish_interval_end'];
                    }
                    if ( array_key_exists('grandclients', $data) )
                    {
                        $backup_status_result_format['grandclients'] = $data['grandclients'];
                    }
                    */

                    /*  **********IMPLEMENT in the FUTURE ***********************
                    if ( array_key_exists('order', $data) )
                    {
                        $backup_status_result_format['sync_msg'] = $data['order'];
                    }
                    if ( array_key_exists('format', $data) )
                    {
                        $backup_status_result_format['finish_interval_start'] = $data['format'];
                    }
                    if ( array_key_exists('start_row', $data) )
                    {
                        $backup_status_result_format['Finish_interval_end'] = $data['start_row'];
                    }
                    if ( array_key_exists('count', $data) )
                    {
                        $backup_status_result_format['grandclients'] = $data['count'];
                    }
                        **********IMPLEMENT in the FUTURE ***********************
                    */


                $backup_status_result_array = $this->BP->get_backup_status($backup_status_result_format);

                if ($backup_status_result_array !== false) {
                    foreach ($backup_status_result_array as &$backup)
                    {
                        if ($backup['replicated'] === false)
                        {
                            if ($filter != null && !$this->should_be_included($backup, $filter)) {
                                continue;
                            }
                            $temp_backup_array = array();
                            $temp_backup_array['app_name'] = (array_key_exists('app_name', $backup) ? $backup['app_name'] :'');
                            if ( array_key_exists('certified', $backup) )
                            {
                                switch ($backup['certified'])
                                {
                                    case true:
                                        $temp_backup_array['certify_status'] = Constants::STATUS_SUCCESS;
                                        break;
                                    default:
                                        $temp_backup_array['certify_status'] = Constants::STATUS_FAILURE;
                                        break;
                                }
                            }
                            else
                            {
                                $temp_backup_array['certify_status'] = 'None';
                            }
                            $temp_backup_array['client_name'] = $clients[$backup['client_id']];
                            $temp_backup_array['complete'] = $backup['complete'];
                            $temp_backup_array['database_name'] = (array_key_exists('database_name', $backup) ? $backup['database_name'] : '');
                            $temp_backup_array['elapsed_time'] = gmdate(Constants::DATE_FORMAT_HRS_MINS_SECS, $backup['elapsed_time']);
                            $temp_backup_array['encrypted'] = $backup['encrypted'];
                            $temp_backup_array['end_date'] = date(Constants::DATE_FORMAT_DATE_THEN_12HR_TIME, $backup['start_time'] + $backup['elapsed_time']);
                            if( array_key_exists('files', $backup) )
                            {
                                $temp_backup_array['files'] = $backup['files'];
                            }
                            $temp_backup_array['id'] = $backup['id'];
                            $temp_backup_array['instance_name'] = (array_key_exists('server_instance_name', $backup) ? $backup['server_instance_name'] : ((array_key_exists('sharepoint_guid', $backup) ? $backup['sharepoint_guid'] :'')));

                            $iid = isset($backup['instance_id']) ? $backup['instance_id'] : false;
                            if ($temp_backup_array['database_name'] == '' && $iid !== false){
                                $instanceInfo = $this->functions->getInstanceNames($iid, $system_id);
                                if ($instanceInfo['app_type'] == Constants::APPLICATION_TYPE_NAME_ORACLE){
                                    $temp_backup_array['database_name'] = $instanceInfo['asset_name'];
                                }
                            }
                            /* Not needed in first out
                            $temp_backup_array['joborder_name'] = $backup[''];
                            */
                            switch ($backup['sync_status'])
                            {
                                case 1:
                                    $temp_backup_array['replication_status'] = Constants::STATUS_NEEDED;
                                    break;
                                case 2:
                                    $temp_backup_array['replication_status'] = Constants::STATUS_COMPLETED;
                                    break;
                                case 4:
                                    $temp_backup_array['replication_status'] = Constants::STATUS_IN_PROGRESS;
                                    break;
                                case 8:
                                    $temp_backup_array['replication_status'] = Constants::STATUS_WAITING;
                                    break;
                                default:
                                    $temp_backup_array['replication_status'] = Constants::STATUS_NOT_APPLICABLE;
                                    break;
                            }
                            $temp_backup_array['size'] = $backup['size'];
                            $temp_backup_array['start_date'] = date(Constants::DATE_FORMAT_DATE_THEN_12HR_TIME, $backup['start_time']);
                            if ( array_key_exists('status', $backup) )
                            {
                                switch ($backup['status'])
                                {
                                    case 0:
                                        $temp_backup_array['status'] = Constants::STATUS_SUCCESS;
                                        break;
                                    case 1:
                                        $temp_backup_array['status'] = Constants::STATUS_WARNING;
                                        break;
                                    default:
                                        $temp_backup_array['status'] = Constants::STATUS_FAILURE;
                                        break;
                                }
                            }
                            else
                            {
                                $temp_backup_array['status'] = Constants::STATUS_RUNNING;
                            }
                            $temp_backup_array['system_name'] = $system_name;
                           // $temp_backup_array['type'] = $this->functions->getBackupTypeString($backup['type']);
                            $temp_backup_array['type'] = $this->functions->getBackupTypeDisplayName($backup['type'], $backup['synthesized']);
                            switch ($backup['verify_status'])
                            {
                                case 1:
                                    $temp_backup_array['verify_status'] = Constants::STATUS_SUCCESS;
                                    break;
                                case 2:
                                    $temp_backup_array['verify_status'] = Constants::STATUS_FAILURE;
                                    break;
                                case 4:
                                    $temp_backup_array['verify_status'] = Constants::STATUS_RUNNING;
                                    break;
                                default:
                                    $temp_backup_array['verify_status'] = Constants::STATUS_NOT_APPLICABLE;
                                    break;
                            }

                            $report_data[] = $temp_backup_array;
                            $report_count += 1;
                        }
                    }
                } else {
                    $report = false;
                }
            }
            $report['count'] = $report_count;
            $report['total'] = $report_count;//$report_total;
            $report['start'] = $report_start;
            $report['data'] = $report_data;
        } else {
            $report['error'] = 500;
            $report['message'] = "Invalid date range provided";
        }
        return $report;
    }

    /*
     * If the user specifies a filter, make sure the object should be included in the report.
     * This function will return true if there are no filters.
     */
    private function should_be_included($backup, $filter) {
        if ($filter !== null) {
            $match = false;
            foreach ($filter as $type => $value) {
                switch ($type) {
                    case 'status':
                        if (($value == Constants::STATUS_SUCCESS && $backup['status'] == 0) ||
                            ($value == Constants::STATUS_WARNING && $backup['status'] == 1) ||
                            ($value == Constants::STATUS_FAILURE && $backup['status'] == 2)) {
                            $match = true;
                            break;
                        }
                }
            }
        }
        return $match;
    }

    public function get_replication_source_history($systems, $data)
    {
        $report = array();
        $report_count = 0;
        //Temporary until more data is available
        $report_total = $report_count;
        $report_start = 1;
        $report_data = array();

        $start_time = false;
        if (array_key_exists('start_date', $data)) {
            $start_time = strtotime($data['start_date']);
        }
        $end_time = false;
        if (array_key_exists('end_date', $data)) {
            $end_time = $this->functions->formatEndDate($data['end_date']);
        }

        $isValidDate = $this->functions->isValidDateRange($start_time, $end_time, false);

        if($isValidDate) {
            foreach ($systems as $system_id => $system_name)
            {
                $clients = $this->BP->get_client_list($system_id);

                $backup_status_result_format = array();
                $backup_status_result_format['system_id'] = $system_id;
                $backup_status_result_format['type'] = array(Constants::BACKUP_TYPE_SECURESYNC_MASTER,
                    Constants::BACKUP_TYPE_SECURESYNC_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_SECURESYNC_INCREMENTAL,
                    Constants::BACKUP_TYPE_SECURESYNC_BAREMETAL,
                    Constants::BACKUP_TYPE_SECURESYNC_DPU_STATE,
                    Constants::BACKUP_TYPE_SECURESYNC_LOCAL_DIRECTORY,
                    Constants::BACKUP_TYPE_SECURESYNC_MS_SQL,
                    Constants::BACKUP_TYPE_SECURESYNC_EXCHANGE,
                    Constants::BACKUP_TYPE_SECURESYNC_MSSQL_FULL,
                    Constants::BACKUP_TYPE_SECURESYNC_MSSQL_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_SECURESYNC_MSSQL_TRANSACTION,
                    Constants::BACKUP_TYPE_SECURESYNC_EXCHANGE_FULL,
                    Constants::BACKUP_TYPE_SECURESYNC_EXCHANGE_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_SECURESYNC_EXCHANGE_INCREMENTAL,
                    Constants::BACKUP_TYPE_SECURESYNC_VMWARE_FULL,
                    Constants::BACKUP_TYPE_SECURESYNC_VMWARE_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_SECURESYNC_VMWARE_INCREMENTAL,
                    Constants::BACKUP_TYPE_SECURESYNC_HYPER_V_FULL,
                    Constants::BACKUP_TYPE_SECURESYNC_HYPER_V_INCREMENTAL,
                    Constants::BACKUP_TYPE_SECURESYNC_HYPER_V_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_SECURESYNC_ORACLE_FULL,
                    Constants::BACKUP_TYPE_SECURESYNC_ORACLE_INCR,
                    Constants::BACKUP_TYPE_SECURESYNC_SHAREPOINT_FULL,
                    Constants::BACKUP_TYPE_SECURESYNC_SHAREPOINT_DIFF,
                    Constants::BACKUP_TYPE_SECURESYNC_UCS_SERVICE_PROFILE_FULL,
                    Constants::BACKUP_TYPE_SECURESYNC_NDMP_FULL,
                    Constants::BACKUP_TYPE_SECURESYNC_NDMP_DIFF,
                    Constants::BACKUP_TYPE_SECURESYNC_NDMP_INCR,
                    Constants::BACKUP_TYPE_SECURESYNC_XEN_FULL );

                if ($data !== NULL and count($data) > 0)
                {
                    /*  Not needed for first out
                    if ( array_key_exists('client_id', $data) )
                    {
                        $backup_status_result_format['client_id'] = $data['client_id'];
                    }*/
                    if ($start_time !== false) {
                        $backup_status_result_format['start_time'] = $start_time;
                    }
                    if ($end_time !== false) {
                        $backup_status_result_format['end_time'] = $end_time;
                    }
                    $backup_status_result_format['grandclients'] = false; //check this
                    /* Not needed for first out
                    if ( array_key_exists('backup_ids', $data) )
                    {
                        $backup_status_result_format['backup_ids'] = $data['backup_ids'];
                    }
                    if ( array_key_exists('sync_msg', $data) )
                    {
                        $backup_status_result_format['sync_msg'] = $data['sync_msg'];
                    }
                    if ( array_key_exists('finish_interval_start', $data) )
                    {
                        $backup_status_result_format['finish_interval_start'] = $data['finish_interval_start'];
                    }
                    if ( array_key_exists('Finish_interval_end', $data) )
                    {
                        $backup_status_result_format['Finish_interval_end'] = $data['Finish_interval_end'];
                    }
                    if ( array_key_exists('grandclients', $data) )
                    {
                        $backup_status_result_format['grandclients'] = $data['grandclients'];
                    }
                    */

                    /*  **********IMPLEMENT in the FUTURE ***********************
                    if ( array_key_exists('order', $data) )
                    {
                        $backup_status_result_format['sync_msg'] = $data['order'];
                    }
                    if ( array_key_exists('format', $data) )
                    {
                        $backup_status_result_format['finish_interval_start'] = $data['format'];
                    }
                    if ( array_key_exists('start_row', $data) )
                    {
                        $backup_status_result_format['Finish_interval_end'] = $data['start_row'];
                    }
                    if ( array_key_exists('count', $data) )
                    {
                        $backup_status_result_format['grandclients'] = $data['count'];
                    }
                        **********IMPLEMENT in the FUTURE ***********************
                    */
                }
                $backup_status_result_array = $this->BP->get_backup_status($backup_status_result_format);

                if ($backup_status_result_array !== false)
                {
                    foreach ($backup_status_result_array as &$backup)
                    {
                        if ($backup['replicated'] === false)
                        {
                            $report_data[$backup['id']] = array();
                            $report_data[$backup['id']]['app_name'] = (array_key_exists('app_name', $backup) ? $backup['app_name'] : '');
                            if (array_key_exists('certified', $backup))
                            {
                                switch ($backup['certified'])
                                {
                                    case true:
                                        $report_data[$backup['id']]['certify_status'] = Constants::STATUS_SUCCESS;
                                        break;
                                    default:
                                        $report_data[$backup['id']]['certify_status'] = Constants::STATUS_FAILURE;
                                        break;
                                }
                            }
                            else
                            {
                                $report_data[$backup['id']]['certify_status'] = 'None';
                            }
                            $report_data[$backup['id']]['client_name'] = $clients[$backup['client_id']];
                            $report_data[$backup['id']]['complete'] = $backup['complete'];
                            $report_data[$backup['id']]['database_name'] = (array_key_exists('database_name', $backup) ? $backup['database_name'] : '');
                            $report_data[$backup['id']]['elapsed_time'] = '';//  Fill in Below
                            $report_data[$backup['id']]['encrypted'] = $backup['encrypted'];
                            $report_data[$backup['id']]['end_date'] = '';//  Fill in Below
                            if (array_key_exists('files', $backup))
                            {
                                $report_data[$backup['id']]['files'] = $backup['files'];
                            }
                            $report_data[$backup['id']]['id'] = $backup['id'];
                            $report_data[$backup['id']]['instance_name'] = (array_key_exists('server_instance_name', $backup) ? $backup['server_instance_name'] : ((array_key_exists('sharepoint_guid', $backup) ? $backup['sharepoint_guid'] : '')));
                            /* Not needed in first out
                            $temp_backup_array['joborder_name'] = $backup[''];
                            */
                            $report_data[$backup['id']]['replication_status'] = ''; //  Fill in Below
                            $report_data[$backup['id']]['size'] = 0;//  Fill in Below
                            $report_data[$backup['id']]['replicated_size'] = $backup['size'];
                            $report_data[$backup['id']]['start_date'] = '';//  Fill in Below
                            $report_data[$backup['id']]['replication_start_date'] = date(Constants::DATE_FORMAT_DATE_THEN_12HR_TIME, $backup['start_time']);
                            $report_data[$backup['id']]['replication_end_date'] = date(Constants::DATE_FORMAT_DATE_THEN_12HR_TIME, $backup['start_time'] + $backup['elapsed_time']);
                            $report_data[$backup['id']]['replication_elapsed_time'] = gmdate(Constants::DATE_FORMAT_HRS_MINS_SECS, $backup['elapsed_time']);
                            $report_data[$backup['id']]['status'] = ''; //  Fill in Below
                            $report_data[$backup['id']]['system_name'] = $system_name;
                            $report_data[$backup['id']]['target_system_name'] = $backup['destination'];
                            $report_data[$backup['id']]['type'] = $this->functions->getBackupTypeString($backup['type']);
                            switch ($backup['verify_status'])
                            {
                                case 1:
                                    $report_data[$backup['id']]['verify_status'] = Constants::STATUS_SUCCESS;
                                    break;
                                case 2:
                                    $report_data[$backup['id']]['verify_status'] = Constants::STATUS_FAILURE;
                                    break;
                                case 4:
                                    $report_data[$backup['id']]['verify_status'] = Constants::STATUS_RUNNING;
                                    break;
                                default:
                                    $report_data[$backup['id']]['verify_status'] = Constants::STATUS_NOT_APPLICABLE;
                                    break;
                            }

                            $report_count += 1;
                        }
                    }

                    $backup_status_result_format['type'] = array( Constants::BACKUP_TYPE_MASTER,
                        Constants::BACKUP_TYPE_DIFFERENTIAL,
                        Constants::BACKUP_TYPE_INCREMENTAL,
                        Constants::BACKUP_TYPE_BAREMETAL,
                        Constants::BACKUP_TYPE_SELECTIVE,
                        Constants::BACKUP_TYPE_MSSQL_FULL,
                        Constants::BACKUP_TYPE_MSSQL_DIFFERENTIAL,
                        Constants::BACKUP_TYPE_MSSQL_TRANSACTION,
                        Constants::BACKUP_TYPE_EXCHANGE_FULL,
                        Constants::BACKUP_TYPE_EXCHANGE_DIFFERENTIAL,
                        Constants::BACKUP_TYPE_EXCHANGE_INCREMENTAL,
                        Constants::BACKUP_TYPE_LEGACY_MSSQL_FULL,
                        Constants::BACKUP_TYPE_LEGACY_MSSQL_DIFF,
                        Constants::BACKUP_TYPE_LEGACY_MSSQL_TRANS,
                        Constants::BACKUP_TYPE_VMWARE_FULL,
                        Constants::BACKUP_TYPE_VMWARE_DIFFERENTIAL,
                        Constants::BACKUP_TYPE_VMWARE_INCREMENTAL,
                        Constants::BACKUP_TYPE_HYPER_V_FULL,
                        Constants::BACKUP_TYPE_HYPER_V_INCREMENTAL,
                        Constants::BACKUP_TYPE_HYPER_V_DIFFERENTIAL,
                        Constants::BACKUP_TYPE_ORACLE_FULL,
                        Constants::BACKUP_TYPE_ORACLE_INCR,
                        Constants::BACKUP_TYPE_SHAREPOINT_FULL,
                        Constants::BACKUP_TYPE_SHAREPOINT_DIFF,
                        //Constants::BACKUP_TYPE_SYSTEM_METADATA,
                        Constants::BACKUP_TYPE_UCS_SERVICE_PROFILE_FULL,
                        Constants::BACKUP_TYPE_NDMP_FULL,
                        Constants::BACKUP_TYPE_NDMP_DIFF,
                        Constants::BACKUP_TYPE_NDMP_INCR,
                        Constants::BACKUP_TYPE_XEN_FULL );

                    $backup_status_result_format['backup_ids'] = array_keys($report_data);

                    $backup_status_result_array = $this->BP->get_backup_status($backup_status_result_format);;

                    if ($backup_status_result_array !== false)
                    {
                        foreach ($backup_status_result_array as &$backup)
                        {
                            $report_data[$backup['id']]['elapsed_time'] = gmdate(Constants::DATE_FORMAT_HRS_MINS_SECS, $backup['elapsed_time']);
                            $report_data[$backup['id']]['end_date'] = date(Constants::DATE_FORMAT_DATE_THEN_12HR_TIME, $backup['start_time'] + $backup['elapsed_time']);
                            switch ($backup['sync_status'])
                            {
                                case 1:
                                    $report_data[$backup['id']]['replication_status'] = Constants::STATUS_NEEDED;
                                    break;
                                case 2:
                                    $report_data[$backup['id']]['replication_status'] = Constants::STATUS_COMPLETED;
                                    break;
                                case 4:
                                    $report_data[$backup['id']]['replication_status'] = Constants::STATUS_IN_PROGRESS;
                                    break;
                                case 8:
                                    $report_data[$backup['id']]['replication_status'] = Constants::STATUS_WAITING;
                                    break;
                                default:
                                    $report_data[$backup['id']]['replication_status'] = Constants::STATUS_NOT_APPLICABLE;
                                    break;
                            }
                            $report_data[$backup['id']]['size'] = $backup['size'];
                            $report_data[$backup['id']]['start_date'] = date(Constants::DATE_FORMAT_DATE_THEN_12HR_TIME, $backup['start_time']);
                            if (array_key_exists('status', $backup))
                            {
                                switch ($backup['status'])
                                {
                                    case 0:
                                        $report_data[$backup['id']]['status'] = Constants::STATUS_SUCCESS;
                                        break;
                                    case 1:
                                        $report_data[$backup['id']]['status'] = Constants::STATUS_WARNING;
                                        break;
                                    default:
                                        $report_data[$backup['id']]['status'] = Constants::STATUS_FAILURE;
                                        break;
                                }
                            }
                            else
                            {
                                $report_data[$backup['id']]['status'] = Constants::STATUS_RUNNING;
                            }
                        }
                    }
                }
                else
                {
                    $report = false;
                }
            }
            $report['count'] = $report_count;
            $report['total'] = $report_count;//$report_total;
            $report['start'] = $report_start;
            $report['data'] = array_values($report_data);
        } else {
            $report['error'] = 500;
            $report['message'] = "Invalid date range provided";
        }
        return $report;
    }

    public function get_restore_history_report( $systems, $data )
    {
        $report = array();
        $report_count = 0;
        //Temporary until more data is available
        $report_total = $report_count;
        $report_start = 1;
        $report_data = array();

        $start_time = false;
        if ( array_key_exists('start_date', $data) )
        {
            $start_time = strtotime($data['start_date']);
        }
        $end_time = false;
        if ( array_key_exists('end_date', $data) )
        {
            $end_time = $this->functions->formatEndDate($data['end_date']);
        }

        $isValidDate = $this->functions->isValidDateRange($start_time, $end_time, false);

        if($isValidDate) {
            foreach ($systems as $system_id => $system_name)
            {
                $clients = $this->BP->get_client_list($system_id);

                $backup_status_result_format = array();
                $backup_status_result_format['system_id'] = $system_id;
                $backup_status_result_format['type'] = array( Constants::BACKUP_TYPE_RESTORE,
                    Constants::BACKUP_TYPE_VIRTUAL_RESTORE,
                    Constants::BACKUP_TYPE_INTEGRATED_BM_RESTORE);

                if ( $data !== NULL and count($data) > 0 )
                {
                    /*  Not needed for first out
                    if ( array_key_exists('client_id', $data) )
                    {
                        $backup_status_result_format['client_id'] = $data['client_id'];
                    }*/
                    if ( $start_time !== false )
                    {
                        $backup_status_result_format['start_time'] = $start_time;
                    }
                    if ( $end_time !== false )
                    {
                        $backup_status_result_format['end_time'] = $end_time;
                    }
                    $backup_status_result_format['grandclients'] = false; //check this
                    /* Not needed for first out
                    if ( array_key_exists('backup_ids', $data) )
                    {
                        $backup_status_result_format['backup_ids'] = $data['backup_ids'];
                    }
                    if ( array_key_exists('sync_msg', $data) )
                    {
                        $backup_status_result_format['sync_msg'] = $data['sync_msg'];
                    }
                    if ( array_key_exists('finish_interval_start', $data) )
                    {
                        $backup_status_result_format['finish_interval_start'] = $data['finish_interval_start'];
                    }
                    if ( array_key_exists('Finish_interval_end', $data) )
                    {
                        $backup_status_result_format['Finish_interval_end'] = $data['Finish_interval_end'];
                    }
                    if ( array_key_exists('grandclients', $data) )
                    {
                        $backup_status_result_format['grandclients'] = $data['grandclients'];
                    }
                    */

                    /*  **********IMPLEMENT in the FUTURE ***********************
                    if ( array_key_exists('order', $data) )
                    {
                        $backup_status_result_format['sync_msg'] = $data['order'];
                    }
                    if ( array_key_exists('format', $data) )
                    {
                        $backup_status_result_format['finish_interval_start'] = $data['format'];
                    }
                    if ( array_key_exists('start_row', $data) )
                    {
                        $backup_status_result_format['Finish_interval_end'] = $data['start_row'];
                    }
                    if ( array_key_exists('count', $data) )
                    {
                        $backup_status_result_format['grandclients'] = $data['count'];
                    }
                        **********IMPLEMENT in the FUTURE ***********************
                    */
                }
                $backup_status_result_array = $this->BP->get_backup_status($backup_status_result_format);

                if ($backup_status_result_array !== false) {
                    foreach ($backup_status_result_array as &$backup)
                    {
                        if ($backup['replicated'] === false)
                        {
                            $temp_backup_array = array();
                            $temp_backup_array['app_name'] = (array_key_exists('app_name', $backup) ? $backup['app_name'] :'');
                            if ( array_key_exists('certified', $backup) )
                            {
                                switch ($backup['certified'])
                                {
                                    case true:
                                        $temp_backup_array['certify_status'] = Constants::STATUS_SUCCESS;
                                        break;
                                    default:
                                        $temp_backup_array['certify_status'] = Constants::STATUS_FAILURE;
                                        break;
                                }
                            }
                            else
                            {
                                $temp_backup_array['certify_status'] = 'None';
                            }
                            $temp_backup_array['client_name'] = $clients[$backup['client_id']];
                            $temp_backup_array['complete'] = $backup['complete'];
                            $temp_backup_array['database_name'] = (array_key_exists('database_name', $backup) ? $backup['database_name'] : '');
                            $temp_backup_array['elapsed_time'] = gmdate(Constants::DATE_FORMAT_HRS_MINS_SECS, $backup['elapsed_time']);
                            $temp_backup_array['encrypted'] = $backup['encrypted'];
                            $temp_backup_array['end_date'] = date(Constants::DATE_FORMAT_DATE_THEN_12HR_TIME, $backup['start_time'] + $backup['elapsed_time']);
                            if( array_key_exists('files', $backup) )
                            {
                                $temp_backup_array['files'] = $backup['files'];
                            }
                            $temp_backup_array['id'] = $backup['id'];
                            $temp_backup_array['instance_name'] = (array_key_exists('server_instance_name', $backup) ? $backup['server_instance_name'] : ((array_key_exists('sharepoint_guid', $backup) ? $backup['sharepoint_guid'] :'')));
                            /* Not needed in first out
                            $temp_backup_array['joborder_name'] = $backup[''];
                            */
                            $temp_backup_array['size'] = $backup['size'];
                            $temp_backup_array['start_date'] = date(Constants::DATE_FORMAT_DATE_THEN_12HR_TIME, $backup['start_time']);
                            if ( array_key_exists('status', $backup) )
                            {
                                switch ($backup['status'])
                                {
                                    case 0:
                                        $temp_backup_array['status'] = Constants::STATUS_SUCCESS;
                                        break;
                                    case 1:
                                        $temp_backup_array['status'] = Constants::STATUS_WARNING;
                                        break;
                                    default:
                                        $temp_backup_array['status'] = Constants::STATUS_FAILURE;
                                        break;
                                }
                            }
                            else
                            {
                                $temp_backup_array['status'] = Constants::STATUS_RUNNING;
                            }
                            $temp_backup_array['system_name'] = $system_name;
                            $temp_backup_array['type'] = $this->functions->getBackupTypeString($backup['type']);

                            $report_data[] = $temp_backup_array;
                            $report_count += 1;
                        }
                    }
                } else {
                    $report = false;
                }
            }
            $report['count'] = $report_count;
            $report['total'] = $report_count;//$report_total;
            $report['start'] = $report_start;
            $report['data'] = $report_data;
        } else {
            $report['error'] = 500;
            $report['message'] = "Invalid date range provided";
        }
        return $report;
    }

    public function get_replication_target_history($systems, $data)
    {
        $report = array();
        $report_count = 0;
        //Temporary until more data is available
        $report_total = $report_count;
        $report_start = 1;
        $report_data = array();

        $start_time = false;
        if (array_key_exists('start_date', $data)) {
            $start_time = strtotime($data['start_date']);
        }
        $end_time = false;
        if (array_key_exists('end_date', $data)) {
            $end_time = $this->functions->formatEndDate($data['end_date']);
        }

        $isValidDate = $this->functions->isValidDateRange($start_time, $end_time, false);

        if($isValidDate) {
            $localSystemID = $this->BP->get_local_system_id();
            $targetName = $this->functions->getSystemNameFromID( $localSystemID );

            $systemNameByClientID = array();
            $allClients = array();
            $localSystemIsInSystemsArray = false;
            foreach ($systems as $system_id => $system_name)
            {
                if ( $system_id == $localSystemID )
                {
                    $localSystemIsInSystemsArray = true;
                }
                $clients = $this->BP->get_grandclient_list($system_id);
                foreach ( $clients as $client_id => $client_name )
                {
                    $systemNameByClientID[$client_id] = $system_name;
                    $allClients[$client_id] = $client_name;
                }
            }

            if ( $localSystemIsInSystemsArray and count($systems) === 1 )
            {
                $sourceSystems = $this->functions->selectReplicatingSystems( );
                foreach ($sourceSystems as $system_id => $system_name)
                {
                    $clients = $this->BP->get_grandclient_list($system_id);
                    foreach ( $clients as $client_id => $client_name )
                    {
                        $systemNameByClientID[$client_id] = $system_name;
                        $allClients[$client_id] = $client_name;
                    }
                }
            }

            if ( $localSystemIsInSystemsArray or (count($allClients) > 0) )
            {
                $backup_status_result_format = array();
                //$backup_status_result_format['system_id'] = $system_id;
                $backup_status_result_format['type'] = array(
                    Constants::BACKUP_TYPE_MASTER,
                    Constants::BACKUP_TYPE_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_INCREMENTAL,
                    Constants::BACKUP_TYPE_BAREMETAL,
                    Constants::BACKUP_TYPE_SELECTIVE,
                    Constants::BACKUP_TYPE_MSSQL_FULL,
                    Constants::BACKUP_TYPE_MSSQL_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_MSSQL_TRANSACTION,
                    Constants::BACKUP_TYPE_EXCHANGE_FULL,
                    Constants::BACKUP_TYPE_EXCHANGE_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_EXCHANGE_INCREMENTAL,
                    Constants::BACKUP_TYPE_LEGACY_MSSQL_FULL,
                    Constants::BACKUP_TYPE_LEGACY_MSSQL_DIFF,
                    Constants::BACKUP_TYPE_LEGACY_MSSQL_TRANS,
                    Constants::BACKUP_TYPE_VMWARE_FULL,
                    Constants::BACKUP_TYPE_VMWARE_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_VMWARE_INCREMENTAL,
                    Constants::BACKUP_TYPE_HYPER_V_FULL,
                    Constants::BACKUP_TYPE_HYPER_V_INCREMENTAL,
                    Constants::BACKUP_TYPE_HYPER_V_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_ORACLE_FULL,
                    Constants::BACKUP_TYPE_ORACLE_INCR,
                    Constants::BACKUP_TYPE_SHAREPOINT_FULL,
                    Constants::BACKUP_TYPE_SHAREPOINT_DIFF,
                    //Constants::BACKUP_TYPE_SYSTEM_METADATA,
                    Constants::BACKUP_TYPE_UCS_SERVICE_PROFILE_FULL,
                    Constants::BACKUP_TYPE_NDMP_FULL,
                    Constants::BACKUP_TYPE_NDMP_DIFF,
                    Constants::BACKUP_TYPE_NDMP_INCR,
                    Constants::BACKUP_TYPE_XEN_FULL,
                    Constants::BACKUP_TYPE_SECURESYNC_MASTER,
                    Constants::BACKUP_TYPE_SECURESYNC_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_SECURESYNC_INCREMENTAL,
                    Constants::BACKUP_TYPE_SECURESYNC_BAREMETAL,
                    Constants::BACKUP_TYPE_SECURESYNC_DPU_STATE,
                    Constants::BACKUP_TYPE_SECURESYNC_LOCAL_DIRECTORY,
                    Constants::BACKUP_TYPE_SECURESYNC_MS_SQL,
                    Constants::BACKUP_TYPE_SECURESYNC_EXCHANGE,
                    Constants::BACKUP_TYPE_SECURESYNC_MSSQL_FULL,
                    Constants::BACKUP_TYPE_SECURESYNC_MSSQL_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_SECURESYNC_MSSQL_TRANSACTION,
                    Constants::BACKUP_TYPE_SECURESYNC_EXCHANGE_FULL,
                    Constants::BACKUP_TYPE_SECURESYNC_EXCHANGE_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_SECURESYNC_EXCHANGE_INCREMENTAL,
                    Constants::BACKUP_TYPE_SECURESYNC_VMWARE_FULL,
                    Constants::BACKUP_TYPE_SECURESYNC_VMWARE_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_SECURESYNC_VMWARE_INCREMENTAL,
                    Constants::BACKUP_TYPE_SECURESYNC_HYPER_V_FULL,
                    Constants::BACKUP_TYPE_SECURESYNC_HYPER_V_INCREMENTAL,
                    Constants::BACKUP_TYPE_SECURESYNC_HYPER_V_DIFFERENTIAL,
                    Constants::BACKUP_TYPE_SECURESYNC_ORACLE_FULL,
                    Constants::BACKUP_TYPE_SECURESYNC_ORACLE_INCR,
                    Constants::BACKUP_TYPE_SECURESYNC_SHAREPOINT_FULL,
                    Constants::BACKUP_TYPE_SECURESYNC_SHAREPOINT_DIFF,
                    Constants::BACKUP_TYPE_SECURESYNC_UCS_SERVICE_PROFILE_FULL,
                    Constants::BACKUP_TYPE_SECURESYNC_NDMP_FULL,
                    Constants::BACKUP_TYPE_SECURESYNC_NDMP_DIFF,
                    Constants::BACKUP_TYPE_SECURESYNC_NDMP_INCR,
                    Constants::BACKUP_TYPE_SECURESYNC_XEN_FULL);
                $backup_status_result_format['grandclients'] = true;

                if ($data !== NULL and count($data) > 0)
                {
                    /*  Not needed for first out
                    if ( array_key_exists('client_id', $data) )
                    {
                        $backup_status_result_format['client_id'] = $data['client_id'];
                    }*/
                    if ($start_time !== false) {
                        $backup_status_result_format['start_time'] = $start_time;
                    }
                    if ($end_time !== false) {
                        $backup_status_result_format['end_time'] = $end_time;
                    }
                    /* Not needed for first out
                    if ( array_key_exists('backup_ids', $data) )
                    {
                        $backup_status_result_format['backup_ids'] = $data['backup_ids'];
                    }
                    if ( array_key_exists('sync_msg', $data) )
                    {
                        $backup_status_result_format['sync_msg'] = $data['sync_msg'];
                    }
                    if ( array_key_exists('finish_interval_start', $data) )
                    {
                        $backup_status_result_format['finish_interval_start'] = $data['finish_interval_start'];
                    }
                    if ( array_key_exists('Finish_interval_end', $data) )
                    {
                        $backup_status_result_format['Finish_interval_end'] = $data['Finish_interval_end'];
                    }
                    if ( array_key_exists('grandclients', $data) )
                    {
                        $backup_status_result_format['grandclients'] = $data['grandclients'];
                    }
                    */

                    /*  **********IMPLEMENT in the FUTURE ***********************
                    if ( array_key_exists('order', $data) )
                    {
                        $backup_status_result_format['sync_msg'] = $data['order'];
                    }
                    if ( array_key_exists('format', $data) )
                    {
                        $backup_status_result_format['finish_interval_start'] = $data['format'];
                    }
                    if ( array_key_exists('start_row', $data) )
                    {
                        $backup_status_result_format['Finish_interval_end'] = $data['start_row'];
                    }
                    if ( array_key_exists('count', $data) )
                    {
                        $backup_status_result_format['grandclients'] = $data['count'];
                    }
                        **********IMPLEMENT in the FUTURE ***********************
                    */
                }
                $backup_status_result_array = $this->BP->get_backup_status($backup_status_result_format);

                if ($backup_status_result_array !== false)
                {
                    foreach ($backup_status_result_array as &$backup)
                    {
                        if ( $localSystemIsInSystemsArray or array_key_exists($backup['client_id'], $allClients) )
                        {
                            $temp_backup_array = array();
                            $temp_backup_array['app_name'] = (array_key_exists('app_name', $backup) ? $backup['app_name'] : '');
                            /*if (array_key_exists('certified', $backup))
                            {
                                switch ($backup['certified'])
                                {
                                    case true:
                                        $temp_backup_array['certify_status'] = Constants::STATUS_SUCCESS;
                                        break;
                                    default:
                                        $temp_backup_array['certify_status'] = Constants::STATUS_FAILURE;
                                        break;
                                }
                            }
                            else
                            {
                                $temp_backup_array['certify_status'] = 'None';
                            }*/
                            $temp_backup_array['client_name'] = $allClients[$backup['client_id']];
                            //$temp_backup_array['complete'] = $backup['complete'];
                            $temp_backup_array['database_name'] = (array_key_exists('database_name', $backup) ? $backup['database_name'] : '');
                            //$temp_backup_array['elapsed_time'] = gmdate(Constants::DATE_FORMAT_HRS_MINS_SECS, $backup['elapsed_time']);
                            $temp_backup_array['encrypted'] = $backup['encrypted'];
                            //$temp_backup_array['end_date'] = date(Constants::DATE_FORMAT_DATE_THEN_12HR_TIME, $backup['start_time'] + $backup['elapsed_time']);
                            if (array_key_exists('files', $backup))
                            {
                                $temp_backup_array['files'] = $backup['files'];
                            }
                            $temp_backup_array['id'] = $backup['id'];
                            $temp_backup_array['instance_name'] = (array_key_exists('server_instance_name', $backup) ? $backup['server_instance_name'] : ((array_key_exists('sharepoint_guid', $backup) ? $backup['sharepoint_guid'] : '')));
                            /* Not needed in first out
                            $temp_backup_array['joborder_name'] = $backup[''];
                            */
                            /*switch ($backup['sync_status'])
                            {
                                case 1:
                                    $temp_backup_array['replication_status'] = Constants::STATUS_NEEDED;
                                    break;
                                case 2:
                                    $temp_backup_array['replication_status'] = Constants::STATUS_COMPLETED;
                                    break;
                                case 4:
                                    $temp_backup_array['replication_status'] = Constants::STATUS_IN_PROGRESS;
                                    break;
                                case 8:
                                    $temp_backup_array['replication_status'] = Constants::STATUS_WAITING;
                                    break;
                                default:
                                    $temp_backup_array['replication_status'] = Constants::STATUS_NOT_APPLICABLE;
                                    break;
                            }*/
                            //$temp_backup_array['size'] = $backup['size'];
                            $temp_backup_array['replicated_size'] = $backup['size'];
                            //$temp_backup_array['start_date'] = date(Constants::DATE_FORMAT_DATE_THEN_12HR_TIME, $backup['start_time']);
                            $temp_backup_array['replication_start_date'] = date(Constants::DATE_FORMAT_DATE_THEN_12HR_TIME, $backup['start_time']);
                            $temp_backup_array['replication_end_date'] = date(Constants::DATE_FORMAT_DATE_THEN_12HR_TIME, $backup['start_time'] + $backup['elapsed_time']);
                            $temp_backup_array['replication_elapsed_time'] = gmdate(Constants::DATE_FORMAT_HRS_MINS_SECS, $backup['elapsed_time']);
                            if (array_key_exists('status', $backup))
                            {
                                switch ($backup['status'])
                                {
                                    case 0:
                                        $temp_backup_array['replication_status'] = Constants::STATUS_SUCCESS;
                                        break;
                                    case 1:
                                        $temp_backup_array['replication_status'] = Constants::STATUS_WARNING;
                                        break;
                                    default:
                                        $temp_backup_array['replication_status'] = Constants::STATUS_FAILURE;
                                        break;
                                }
                            }
                            else
                            {
                                $temp_backup_array['replication_status'] = Constants::STATUS_RUNNING;
                            }
                            $temp_backup_array['source_system_name'] = $systemNameByClientID[$backup['client_id']];
                            $temp_backup_array['target_system_name'] = $targetName;
                            $temp_backup_array['type'] = $this->functions->getBackupTypeString($backup['type']);
                            /*switch ($backup['verify_status'])
                            {
                                case 1:
                                    $temp_backup_array['verify_status'] = Constants::STATUS_SUCCESS;
                                    break;
                                case 2:
                                    $temp_backup_array['verify_status'] = Constants::STATUS_FAILURE;
                                    break;
                                case 4:
                                    $temp_backup_array['verify_status'] = Constants::STATUS_RUNNING;
                                    break;
                                default:
                                    $temp_backup_array['verify_status'] = Constants::STATUS_NOT_APPLICABLE;
                                    break;
                            }*/

                            $report_data[] = $temp_backup_array;
                            //$report_data[] = $backup;
                            $report_count += 1;
                        }
                    }
                }
                else
                {
                    $report = false;
                }
            }
            $report['count'] = $report_count;
            $report['total'] = $report_count;//$report_total;
            $report['start'] = $report_start;
            $report['data'] = array_values($report_data);
        } else {
            $report['error'] = 500;
            $report['message'] = "Invalid date range provided";
        }
        return $report;
    }

    public function get_replication_history($systems, $data)
    {
        $report = array();
        $report_count = 0;
        //Temporary until more data is available
        $report_total = $report_count;
        $report_start = 1;

        $source_report = $this->get_replication_source_history($systems, $data);



        if( isset($source_report['error']) ) {
            $report = $source_report;
        } else {
            $target_report = $this->get_replication_target_history($systems, $data);

            if( isset($target_report['error']) ) {
                $report = $target_report;
            } else {
                if ( isset($source_report['count']) and $source_report['count'] > 0 ) {
                    $report['show_source_report'] = true;
                    $report_count += $source_report['count'];
                    $report['source_data'] = $source_report['data'];
                } else {
                    $report['show_source_report'] = false;
                }

                if ( isset($target_report['count']) and $target_report['count'] > 0 ) {
                    $report['show_target_report'] = true;
                    $report_count += $target_report['count'];
                    $report['target_data'] = $target_report['data'];
                } else {
                    $report['show_target_report'] = false;
                }

                $report['count'] = $report_count;
                $report['total'] = $report_count;//$report_total;
                $report['start'] = $report_start;
            }
        }

        // Decide what message the user should see instead of a blank report.
        if ( isset($report['show_source_report']) and isset($report['show_target_report']) and $report['show_source_report'] === false and $report['show_target_report'] === false )
        {
            $atLeastOneSystemSupportsReplication = false;
            $atLeastOneSystemIsConfiguredAsAReplicationSource = false;  //By 'Configured', I mean actively replicating
            $moreThanOneSystem = ( count($systems) > 1 );
            $localSystemIsInTheSystemArray = false;
            $localSystemID = $this->BP->get_local_system_id();
            foreach ($systems as $system_id => $system_name)
            {
                $localSystemIsInTheSystemArray = ($localSystemIsInTheSystemArray or ($localSystemID === $system_id));
                $canReplicate = $this->BP->replication_supported($system_id);
                $replicating = false;
                if ($canReplicate == true)
                {
                    $replicating = $this->BP->is_replication_configured($system_id);
                }
                $atLeastOneSystemSupportsReplication = ($atLeastOneSystemSupportsReplication or $canReplicate);
                $atLeastOneSystemIsConfiguredAsAReplicationSource = ($atLeastOneSystemIsConfiguredAsAReplicationSource or $replicating);
            }

            if ( $atLeastOneSystemSupportsReplication === true )
            {
                if ( $atLeastOneSystemIsConfiguredAsAReplicationSource === true )
                {
                    $report['message'] = 'A Backup Copy did not occur during the given date range.';
                }
                else
                {
                    if ( $localSystemIsInTheSystemArray )
                    {
                        $replicatingSystems = $this->functions->selectReplicatingSystems();
                        if ( is_array($replicatingSystems) and count($replicatingSystems) > 0 )
                        {
                            $report['message'] = 'A Backup Copy did not occur during the given date range';
                        }
                        else
                        {
                            if ( $moreThanOneSystem )
                            {
                                $report['message'] = 'None of the selected Appliances are configured for Backup Copy to a Hot Target.';
                            }
                            else
                            {
                                $report['message'] = 'The selected Appliance is not configured for Backup Copy to a Hot Target.';
                            }
                        }

                    }
                    else
                    {
                        if ( $moreThanOneSystem )
                        {
                            $report['message'] = 'None of the selected Appliances are configured for Backup Copy to a Hot Target.';
                        }
                        else
                        {
                            $report['message'] = 'The selected Appliance is not configured for Backup Copy to a Hot Target.';
                        }
                    }
                }
            }
            else
            {
                if ( count($systems) > 1 )
                {
                    $report['message'] = 'None of the selected Appliances support Backup Copy to a Hot Target.';
                }
                else
                {
                    $report['message'] = 'The selected Appliance does not support Backup Copy to a Hot Target.';
                }
            }
        }

        return $report;
    }

}