<?php

$dir = '/api/includes/reports';

class ReplicationFootprintReport
{
    private $BP;
    const FOOTPRINT_REPORT_VAULTING_MESSAGE = '(Systems configured for Vaulting are not included in the report.)';

    public function __construct( $BP, $functionsClass )
    {
        $this->BP = $BP;
        $this->functions = $functionsClass;
    }

    public function get_replication_footprint_report($sid, $data)
    {
        $report = array();
        /*$localSystemID = $this->BP->get_local_system_id();
        if ( $sid !== false and $localSystemID !== $sid )
        {
            // Footprint report is only available on the local system
        }*/

        $footprintReportUtilOutput = shell_exec('/usr/bp/bin/footprintReportUtil --show -v 0');
        if( $footprintReportUtilOutput !== false )
        {
            $footprintReportUtilOutputArray = explode("\n", $footprintReportUtilOutput);
            if ( count($footprintReportUtilOutputArray) > 6 )
            {
                $systemAndVersionArray = preg_split('/\s+/', $footprintReportUtilOutputArray[1], 4);
                if ( count($systemAndVersionArray) == 4 )
                {
                    $report['local_system_name'] = $systemAndVersionArray[1];
                    $report['local_system_version'] = $systemAndVersionArray[3];
                }
                else
                {
                    // The string can't be broken apart correctly, so output the whole thing
                    $report['system_name'] = $footprintReportUtilOutputArray[1];
                    $report['system_version'] = $footprintReportUtilOutputArray[1];
                }
                $report['report_date'] = substr( $footprintReportUtilOutputArray[3], 13 );
                $report['replicated_systems'] = array();
                foreach ( array_slice($footprintReportUtilOutputArray, 7) as $replicatedSourceData )
                {
                    if ( $replicatedSourceData !== $this::FOOTPRINT_REPORT_VAULTING_MESSAGE )
                    {
                        $replicatedSourceDataArray = preg_split('/\s+/', $replicatedSourceData, 2);
                        if ( count($replicatedSourceDataArray) == 2 )
                        {
                            $report['replicated_systems'][] = array( 'system_name' => $replicatedSourceDataArray[0],
                                'data_size' => $replicatedSourceDataArray[1] );
                        }
                    }
                }
            }
            else
            {
                $report['error'] = shell_exec('/usr/bp/bin/footprintReportUtil --show -v 0 2>&1');
            }
        }
        else
        {
            $report = false;
            // Add a failure message here
        }
        return $report;

    }

}