<?php

class Users
{
    private $BP;
     
    public function __construct($BP)
    {
		$this->BP = $BP;

    }
 
    public function get($which)
    {
		$allUsers = array();
	
		$users = $this->BP->get_user_list();
		if ($users !== false) {
			foreach ($users as $id => $name) {
				if ($which > 0 and $id != $which) {
					continue;
				}
				$userInfo = $this->BP->get_user_info($id);
				if ($userInfo !== false) {
                    $eachUser = array ( 'id'=>$userInfo['id'],
                                        'name'=>$userInfo['name'],
                                        'superuser'=>$userInfo['superuser'],
                                        'vault_user'=>$userInfo['vault_user'],
                                        'customers'=>isset($userInfo['customers']) ? $userInfo['customers'] : null,
                                        'locations'=>isset($userInfo['locations']) ? $userInfo['locations'] : null,
                                        'systems'=>isset($userInfo['systems']) ? $userInfo['systems'] : null
                                        );
                    if (isset($userInfo['administrator'])) {
                        $eachUser['administrator'] = $userInfo['administrator'];
                    }
                    $allUsers['data'][] = $eachUser;
				}
			}
		}
		return($allUsers);
    }

    public function put($which, $data)
    {
        $status = false;
        $userArray = array();
        if ($which != -1) {
            $userArray['id'] = $which;
            if (isset($data['name'])) {
                $userArray['name'] = $data['name'];
            }
            if (isset($data['superuser'])) {
                $userArray['superuser'] = $data['superuser'];
            }

            $userInfo = $this->BP->get_user_info($which);
            if ($userInfo !== false) {
                $userName = $userInfo['name'];
                $superUser = $userInfo['superuser'];
                if (isset($data['password'])) {
                    if(isset($data['force']) && $data['force'] === true){
                        $userArray['password'] = $data['password'];
                    }
                    else if (isset($data['current_password'])) {
                        $valid = $this->BP->authenticate($userName, $data['current_password']);
                        if ($valid !== -1) {
                            $userArray['password'] = $data['password'];
                        } else {
                            $msg = "Incorrect password.";
                        }
                    } else {
                        $msg = "Specify the current password.";
                    }
                }
                if (!$superUser) {
                    if (isset($data['customers'])) {
                        $userArray['customers'] = $data['customers'];
                    }
                    if (isset($data['locations'])) {
                        $userArray['locations'] = $data['locations'];
                    }
                    if (isset($data['systems'])) {
                        $userArray['systems'] = $data['systems'];
                    }
                }
            }
            if (isset($msg)) {
                $status['error'] = 500;
                $status['message'] = $msg;
            } else {
                $status = $this->BP->save_user_info($userArray);
            }
        }
        return $status;
    }

    public function post($data)
    {
        $result = array();
        $userArray = array();
        if (isset($data['name'])) {
            $userArray['name'] = $data['name'];
        }
        if (isset($data['superuser'])) {
            $userArray['superuser'] = $data['superuser'];
        }
        if (isset($data['password'])) {
            $userArray['password'] = $data['password'];
        }
        if (isset($data['customers'])) {
            $userArray['customers'] = $data['customers'];
        }
        if (isset($data['locations'])) {
            $userArray['locations'] = $data['locations'];
        }
        if (isset($data['systems'])) {
            $userArray['systems'] = $data['systems'];
        }
        $output = $this->BP->save_user_info($userArray);

        if ($output !== false) {
            $users = $this->BP->get_user_list();
            if ($users !== false) {
                foreach ($users as $id => $name) {
                    if ($name === $data['name']) {
                        $newUser['id'] = $id;
                    }
                }
            }
            $result['result'][] = $newUser;
        } else {
            $result = $output;
        }
        return $result;
    }


    public function delete($which)
    {
        $result = false;
        if ($which !== -1) {
            $userInfo = $this->BP->get_user_info($which);
            if ($userInfo !== false) {
                $userName = $userInfo['name'];
                // do not remove root user
                if ($userName !== Constants::NVP_NAME_ROOT) {
                    $result = $this->BP->remove_user($which);
                } else {
                    $result['error'] = 500;
                    $result['message'] = "Root user cannot be removed";
                }
            } else {
                $result['error'] = 500;
                $result['message'] = "Cannot get user information.";
            }
        } else {
            $result['error'] = 500;
            $result['message'] = "User ID must be specified";
        }
        return $result;
    }

}

?>
