<?php
// defines BP, xml, action, cookie
require 'header.php';
// defines functions for URL parsing.
require('urloptions.php');
// converts xml string to client array
require 'xmlreader.php';

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
$clientID = isset($_GET['cid']) ? $_GET['cid'] : "-1";
$ip = isset($_GET['ip']) ? $_GET['ip'] : "";
$osFamily = isset($_GET['os']) ? $_GET['os'] : "";
$credID = isset($_GET['credid']) ?  (int)$_GET['credid'] : "0";
$singleClient = $_GET['singleclient']  == '1' ? true : false;


switch ($action) {	
	case "check":
	global $Log;
		$available = $BP->agent_update_available($clientID, $dpuID);
		$Log->writeVariable($available);
		if($available !== false){
			$xml->push("root");
			foreach($available as $updates){
				$xml->push("Update");
				if(array_key_exists("clientID", $updates)){
					$xml->element("clientID", $updates['clientID']);
				}
				$name = getClientName($BP, $updates['clientID'], $dpuID);
				$Log->writeVariable("name  " . $name);
				if($name !== false) {
					$ip = getIP($BP, $xml, $name, $dpuID);
					$xml->element("Name", $name);
					$xml->element("IP", $ip);
				}
				
				if(array_key_exists("isUpdateAvailable", $updates)){
					$xml->element("UpdateAvailable", $updates['isUpdateAvailable']);
				}
				$xml->pop(); //update
			}
			$xml->pop(); //root
		} else {
			$BP->buildResult($xml, false, $BP->getError());
		}
		echo ($xml->getXml());
		break;
		
	case "push":
	
	$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
	$clientID = isset($_GET['cid']) ? $_GET['cid'] : "-1";
	$ip = isset($_GET['ip']) ? $_GET['ip'] : "";
	$cname = isset($_GET['cname']) ? $_GET['cname'] : "";
	$address = $ip != "" ? $ip : $cname;
	
	$osFamily = isset($_GET['os']) ? $_GET['os'] : "";
	$credID = isset($_GET['credid']) ?  (int)$_GET['credid'] : "0";
	
		//if $singleClient is true, we're pushing/updating agent from client registraton pane, 
		//so we have all the info to pass through the http service.
		
		//$address is ip if available, else use client name
		if($singleClient) {  
			$result = $BP->push_agent($clientID, $address, $osFamily, $credID, $dpuID);
			if($result !== false) {
				$BP->buildResult($xml, true);
			} else {
				$BP->buildResult($xml, false, $BP->getError());
			}
			
			//get/save new client info.
			$result = saveClient($BP, $clientID, $dpuID);
			
			if($result == false) {
				$BP->buildResult($xml, false, $BP->getError());
			}

		} else {
			$clientXML = $_REQUEST['clients'];
			$clientsArray = xmlToClient($clientXML);
			
			$xml->push("root");
			foreach($clientsArray as $clients) {
				 
				$clientID = $clients['id'];
						$clientInfo = $BP->get_client_info($clientID, $dpuID);
					if($clientInfo !== false) {
						if(array_key_exists('name', $clientInfo)){
							$clientName = $clientInfo['name'];
						}
						if(array_key_exists('os_type', $clientInfo)){
							$os_type = $clientInfo['os_type'];
							if(strstr($os_type, "Windows")){
								$osFamily = "Windows";
							}
						}
						$resultArray = array();
				
						if(array_key_exists('credentials', $clientInfo)){
							$credentialsArray = $clientInfo['credentials'];
							if(array_key_exists('credential_id', $credentialsArray)){
								$credID = $credentialsArray['credential_id'];
							}
						}
						$ip = getIP($BP, $xml, $clientName, $dpuID);
						
						//=================================
						$available = $BP->agent_update_available($clientID, $dpuID);
						if($available !== false){
							$doUpdate = true;
							foreach($available as $updates){
								if(array_key_exists("clientID", $updates)){
									$name = getClientName($BP, $updates['clientID'], $dpuID);
								}
								if(array_key_exists("isUpdateAvailable", $updates)){
									$doUpdate = $updates['isUpdateAvailable'];
								}
								if($doUpdate == false){
									$msg = "Latest available agent version is installed.";
									$xml->push( "result", array("Client" => $name,
												"Message" => $msg));
									$xml->pop();
								}
							}
						}

						//=================================
						if($doUpdate !== false){
							$address = $ip == '0.0.0.0' ? $name : $ip;
							$result = $BP->push_agent($clientID, $address, $osFamily, $credID, $dpuID);
							if($result !== false) {
								$msg = "Success";
								$xml->push( "result", array("Client" => $clientName,
										"Message" => $msg));
								$xml->pop();
							} else {
								$msg = $BP->getError();
								global $Log;
								$Log->writeError($msg);
								$xml->push( "result", array("Client" => $clientName,
											"Message" => $msg));
								$xml->pop();
							}
							saveClient($BP, $clientID, $dpuID);
						}
					}
				}
			$xml->pop(); //root
		}

		echo ($xml->getXml());
		break;
}

function getIP($BP, $xml, $clientName, $dpuID){
	$ip = "0.0.0.0";
	$hostInfo = $BP->get_host_info($clientName, $dpuID);
	if($hostInfo !==false) {
		if(isset($hostInfo['ip'])) {
			$ip = $hostInfo['ip'];
		}
	}
	return $ip;
}

function saveClient($BP, $clientID, $dpuID) {
	$clientInfo = $BP->get_client_info($clientID, $dpuID);
	$result = true;
	if($clientInfo !== false){
		$clientUpdate = array();
		$clientUpdate['id'] = $clientInfo['id'];
		$result = $BP->save_client_info($clientUpdate, $dpuID);
	}
	return $result;
}
$BP->destroyCookie();
?>
