<?php
// defines BP, xml, action, cookie
require 'header.php';

// general backup list operations.
require 'listsbase.php';

switch ($action) {

	case "test":
			// see if baremetal media tested
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			// if a calendar specified, see if it has baremetals, otherwise, move forward with the test.
			$bTestBareMetal = (isset($_REQUEST['cal'])) ? checkSpecifiedCalendar($xml, $BP, $dpuID) : true;
			if ($bTestBareMetal) {	
				if (isset($_REQUEST['clients'])) {
					$clients = $_REQUEST['clients'];				
					$resultArray = $BP->is_bm_media_tested($clients, $dpuID);							
					if (is_array($resultArray)) {
						$xml->push("root");
						foreach ($resultArray as $result) {
							$xml->emptyelement("BareMetal", array("Client" => $result));
						}
						$xml->pop(); // root
					} else {
						$result = $resultArray;
						$BP->buildResult($xml, $result);
					}
				} else {
					$BP->buildResult($xml, false, "must specify client ID's to check baremetal media verification.");
				}
			} else {
				$BP->buildResult($xml, true);
			}							
			echo($xml->getXml());			
			break;
}

//
// If a calendar is specified, see if it contains any bare metal backups.
//
function checkSpecifiedCalendar($xml, $BP, $dpuID)
{
	$result = false;
	
	$ListBase = new ListBase();			
	if (($id = $ListBase->getID($BP, 'get_calendar_list', $dpuID)) == -1) {
		$BP->buildResult($xml, false, "Error: cannot find calendar to check for baremetal backups.");
	} else {
		$iCalendarContent = $BP->get_calendar($id, $dpuID);
		if ($iCalendarContent === false) {
			$BP->buildResult($xml, false);
		} else {
			//
			// Check to see if bare metal contained
			//
			$bareMetalBackup = "SUMMARY:BareMetal";
			if (strpos($iCalendarContent, $bareMetalBackup)) {
				$result = true;
			}
		}		
	}
	
	return $result;
}



$BP->destroyCookie();
?>
