<?php
// defines BP, xml, action, cookie
require 'header.php';

// defines functions for master.ini processing
require('baseini.php');

switch ($action) {				
	case "list":
			// Get the CMC section.
			$xml->push("root");
			$BP->bypass_cookie(2);
			$dpuID = $BP->get_local_system_id();
			displaySection($xml, $BP, "CMC");				
			// Get the user preferences.
			if (isset($_GET['user'])) {
				$userName = $_GET['user'];
				buildUserPreferences($BP, $xml, $userName);
				buildNavGroups( $BP, $xml, $userName );
			}				
			$xml->pop(); // root
			echo($xml->getXml());
			break;
	
	case "update":
			// to update a field/value pair or add if not present
			$bValid = false;
			if (isset($_REQUEST['field'])) {
				$field = $_REQUEST['field'];
				if (isset($_REQUEST['value'])) {
					$value = $_REQUEST['value'];
					$bValid = true;
				} else {
					$BP->buildResult($xml, false, "error: CMC configuration: no field value specified.");
					echo($xml->getXml());
				}
			} else {
				$BP->buildResult($xml, false, "error: CMC configuration: no field name specified.");
				echo($xml->getXml());
			}		
			
			if ($bValid) {
				$BP->buildResult($xml, $BP->set_ini_value($section, $field, $value));
				echo($xml->getXml());
			}			
			break;
}


//
// This function operates at start of day to see if the given user should
// show the splash screen when navigating to backup.  If the username is not
// found, returns false.
//
function buildUserPreferences($BP, $xml, $userName)
{
	$nvpList = $BP->get_nvp_list("preferences", $userName);
	if ($nvpList !== false && count($nvpList) > 0) {
		foreach ($nvpList as $name => $value) {
			$xml->element($name, $value);
		}
	}
	
	// Get Satori preferences - do not want user to have to complete
    // setup wizard in legacy if already done in Satori
    $satoriPreferences = $BP->get_nvp_list("user_preference", "root");
    if ($satoriPreferences !== false && count($satoriPreferences) > 0) {
        foreach ($satoriPreferences as $name => $value) {
            $xml->element($name, $value);
        }
    }
}

// Function adds the navigation group for startup
function buildNavGroups($BP, $xml, $userName ) {
	$nvpList = $BP->get_nvp_list("navGroups", "users");
	if ($nvpList !== false && count($nvpList) > 0) {
		foreach ($nvpList as $name => $value) {
			$xml->element($name, $value);
		}
	}
}

$BP->destroyCookie();
?>
