<?php
// defines BP, xml, action, cookie
require 'header.php';

$localID = $BP->get_local_system_id();
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $localID;

// figure out which sysID to used based on view.
$sysID = $grandClientView ? $localID : $dpuID;

switch ($action) {				
	case "list":
			// List the encryption information.	
			$cryptInfo = $BP->get_crypt_info($sysID);
			if ($cryptInfo === false) {
				$BP->buildResult($xml, false);
			} else {
				$xml->push('root');
				displayCryptInfo($xml, $cryptInfo);
				$xml->pop();
			}
			echo($xml->getXml());
			break;
					
	case "update":
			// Update crypt information.
			if (!isset($_REQUEST['active']) && !isset($_REQUEST['enabled']) && !isset($_REQUEST['persistent']) &&
				!isset($_REQUEST['passphrase']) && !isset($_REQUEST['current_passphrase'])) {
				$BP->buildResult($xml, false,
					"error: must specify active, enabled, and/or a passphrase to update encryption state");
			} else {
				$cryptInfo = array();
				$options = array ('current_passphrase' => 'current_passphrase',
								  'new_passphrase' => 'passphrase');
				$bOptions = array();
				$cryptInfo = buildOptions($cryptInfo, $options, $bOptions);
				if (isset($_REQUEST['active'])) {
					$flag = $_REQUEST['active'];
					$bFlag = $flag == '1' ? true : false;
					$cryptInfo = array_merge($cryptInfo, array ("active" => $bFlag));
				}
				if (isset($_REQUEST['enabled'])) {
					$flag = $_REQUEST['enabled'];
					$bFlag = $flag == '1' ? true : false;
					$cryptInfo = array_merge($cryptInfo, array ("enabled" => $bFlag));
				}
				if (isset($_REQUEST['persistent'])) {
					$flag = $_REQUEST['persistent'];
					$bFlag = $flag == '1' ? true : false;
					$cryptInfo = array_merge($cryptInfo, array ("persistent" => $bFlag));
				}
				$BP->buildResult($xml, $BP->save_crypt_info($cryptInfo, $sysID));
			}
			echo($xml->getXml());
			break;
					
	case "backup":
			// Save crypt keys to CD. LOCAL SYSTEM ONLY, won't be shown unless local.
			/*
			$systemID = isset($_REQUEST['sid']) ? (int)$_REQUEST['sid'] : $BP->get_local_system_id();
			if (!isset($_REQUEST['sid']) || $systemID == $BP->get_local_system_id()) {
				$BP->buildResult($xml, $BP->backup_crypt_keyfile());
			} else {
				$BP->buildResult($xml, false, "Encryption key file backup only allowed on local system.");
			}
			*/
			$BP->buildResult($xml, $BP->backup_crypt_keyfile());
			echo($xml->getXml());
			break;
			
	case "support":
			// See if encryption is supported on this system.
			$result = $BP->encryption_supported($sysID);
			$xml->push('root');
			$xml->element('EncryptionSupported', $result == true ? "1" : "0");
			$xml->pop(); // root
			echo($xml->getXml());
			break;
}


function displayCryptInfo($xml, $cryptInfo)
{
	$xml->push("EncryptionStatus");
	if (array_key_exists('active', $cryptInfo))
		$xml->element('Active', $cryptInfo['active'] == true ? "1" : "0");
	if (array_key_exists('enabled', $cryptInfo))
		$xml->element('Enabled', $cryptInfo['enabled'] == true ? "1" : "0");
	if (array_key_exists('persistent', $cryptInfo))
		$xml->element('Persistent', $cryptInfo['persistent'] == true ? "1" : "0");
	if (array_key_exists('passphrase_set', $cryptInfo))
		$xml->element('PassphraseSet', $cryptInfo['passphrase_set'] == true ? "1" : "0");
	$xml->pop(); // EncryptionStatus
}


$BP->destroyCookie();
?>