<?php
// defines BP, xml, action, cookie
require '../header.php';
require 'dpurestorefunctions.php';
global $Log;

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

switch ($action) {
	
	case "media":  // get connected archive media.
		$daemonStatus = $BP->get_uarchive_status($dpuID);
		if ($daemonStatus !== false) {
			if ($daemonStatus === "off") {
				$BP->start_uarchive($dpuID);
		  	}
			$result = $BP->get_connected_archive_media($dpuID);
			if ($result !== false) {
				$xml->push('root');
				foreach ($result as $media) {
					if (array_key_exists('name', $media)) {
						if($media['type'] != "tape" && $media['type'] != "changer") {
							$xml->push("Media");	
							$xml->element('Name', $media['name']);
							$xml->element('Mounted', (array_key_exists('is_mounted', $media) && $media['is_mounted'] == true) ? "1" : "0");
							$xml->element('isBusy', (array_key_exists('is_busy', $media) && $media['is_busy'] == true) ? "1" : "0");
							$xml->pop(); //media	
						}
					}
		  		}
		  		$xml->pop(); //root
			} else {
				$BP->buildResult($xml, false);
			}	
		} else {
			$BP->buildResult($xml, false);
		}
	  	echo($xml->getXml());
	  	break;
		
	case "path":
		$selectedMedia = $_GET['media'];
		$path = $BP->get_archive_state_path($selectedMedia, $dpuID);	
		if ($path !== false) {
			$mode = $BP->get_dr_from_archive_mode($path, $dpuID);
			if($mode !== false) {
				$xml->push("root");
				foreach($mode as $style) {
					$xml->push("Style", array("old_new" => $style, "path" =>$path));
					$xml->pop();
				}
				
				$xml->pop();
			} else {
				$BP->buildResult($xml, false, $BP->getError());
			}
		}
		
		echo($xml->getXml());
	  	break;
	
	case "metadata_check":
		$path = isset($_GET['path']) ? $_GET['path'] : "";
		$bReplace = $_GET['breplacestorage'] == '1' ? true : false;
		$action = 'check';
		
		$filter = array('backup_path' => $path, 
						'save_new_storage' => $bReplace,
						'action' => $action);
			
		$result = $BP->restore_appliance_metadata($filter);
		
		if($result !== false) {
				//for 7.0 - empty array.  We may need these notices one day, but not today.
			if(!empty($result)) {
				global $Log;
				foreach($result as $msg) {
					$Log->writeVariable($msg);
					//$BP->setWarning($xml, $msg);
				}
				$result = array();
			}
			$BP->buildResult($xml, true);			
		} else {
			$BP->buildResult($xml, false, $BP->getError());
		}
	
		echo($xml->getXml());
	  	break;
				
	case "metadata_restore":
		$path = isset($_GET['path']) ? $_GET['path'] : "";
		$bReplace = $_GET['breplacestorage'] == '1' ? true : false;
		$action = 'restore';
		
		$filter = array('backup_path' => $path, 
						'save_new_storage' => $bReplace,
						'action' => $action);
			
		$result = $BP->restore_appliance_metadata($filter);
			if($result !== false) {
				//$BP->setWarning($xml, $result);
				$BP->buildResult($xml, true);	
			
			} else {
				$BP->buildResult($xml, false, $BP->getError());
			}

		echo($xml->getXml());
	  	break;
	
				
	case "state":  // restore DPU state.
		$selectedMedia = $_GET['media'];
		$path = $BP->get_archive_state_path($selectedMedia, $dpuID);
		if ($path !== false) {
			$versionCheck = $BP->dpu_restore_archive_check_version($path);
			if($versionCheck !== false) {
				$result = $BP->dpu_restore_archive_state($selectedMedia, $path);
				if ($result !== false) {
					$BP->buildResult($xml, $path);
				} else {
					$BP->buildResult($xml, false);
				}
			} else {
				$BP->buildResult($xml, false);
			}
		}else {
			$BP->buildResult($xml, false);		
		}		
			
	echo($xml->getXml());
	break;
		
	case "encryption":
		$path = $_GET['path'];
		$result = $BP->is_archive_dpu_encryption_enabled($path);
		if ($result !== false){
			$BP->buildResult($xml, $result);
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;

	case "version":
		$path = $_GET['path'];
		$result = $BP->dpu_restore_archive_check_version($path);
		if ($result !== false){
			$BP->buildResult($xml, $result);
		}else{
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
		
	case "mount":
		if (isset($_GET['media'])) {
			$mediaName = $_GET['media'];
			$BP->buildResult($xml, $BP->mount_archive_media($mediaName, $dpuID));
			} else {
				$BP->buildResult($xml, false, 'archive media name to mount must be specified.');
			}
		echo($xml->getXml());
		break;
	
	case "validate":
	
	$bTarget = $_GET['btargetselected'] == '1' ? true : false;
	$restoreClientDevices = xmlToClients($_REQUEST['clients']);
	if($restoreClientDevices !== false) {
		foreach($restoreClientDevices as $ClientDevices){
			if (array_key_exists('device_name', $ClientDevices)) {
				$devices[] = $ClientDevices['device_name'];
			}
		}
		if($bTarget === false) {
			$devices = array();
		}
		$validate = $BP->archive_validate_devices($bTarget, $devices);
		
		if($validate !== false){
			$BP->buildResult($xml, $validate);
		}else {
			$BP->buildResult($xml, false);
		}
	}else {
		$BP->buildResult($xml, false);
	}
	
	echo($xml->getXml());
	break;

}

$BP->destroyCookie();
?>
