<?php

function xmlToClients($xml)
{
	$parser = xml_parser_create();
	xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
	xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
	xml_parse_into_struct($parser, $xml, $values, $tags);
	xml_parser_free($parser);

	$returnArray = array();
	$oneClient = array();

	$stack = array();
	$i = 0;
	foreach ($values as $val) {
		if ($val['type'] == "open") {
			if ($val['tag'] != "Clients" && $val['tag'] != "Client") {
				$field = buildFieldName($val['tag']);
				array_push($stack, $field);
			}

		} else if ($val['type'] == "close") {
			if ($val['tag'] != "Clients" && $val['tag'] != "Client") {
				array_pop($stack);
			}
		} else if ($val['type'] == "complete") {
			$field = buildFieldName($val['tag']);
			
			if($val['value'] !== "undefined") {
				array_push($stack, $field);
				setArrayValue($oneClient, $stack, $val['value'], false);
				array_pop($stack);
			}
				if ($val['tag'] == 'Path') {
					$returnArray[] = $oneClient;
					$oneClient = array();
			}
		}
	}

	return $returnArray;
	
}

function setArrayValue(&$array, $stack, $value, $bBoolean) {
	if ($stack) {
		$key = array_shift($stack);
		setArrayValue($array[$key], $stack, $value, $bBoolean);
	} else {
		if ($bBoolean) {
			$array = $value == 'true' ? true : false;
		}else {
			$array = $value;
		}
	}
}

function buildFieldName($tag)
{
	$field = "";

	switch ($tag) {
		case "Name":
			$field = "client_name";
			break;
		
		case "Device":
			$field = "device_name";
			break;
		
		case "Path":
			$field = "device_path";
			break;
	}

	return $field;
}
?>
