<?php
// defines BP, xml, action, cookie
require 'header.php';

$localID = $BP->get_local_system_id();
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $localID;

// figure out which sysID to used based on view.
$sysID = $grandClientView ? $localID : $dpuID;

switch ($action) {

	case "list":	// list exchange information
			$clientID = isset($_GET['cid']) ? (int)$_GET['cid'] : -1;
			$bIsSupported = $BP->is_appconfig_supported($dpuID);
			$bCache = isset($_GET['cache']) ? true : false;
			
			if ($grandClientView) {
				$grandClientExchangeInfo = $BP->get_grandclient_exchange_info($clientID);
				$exchangeInfo = false;
			} else {
				$exchangeInfo = $BP->get_exchange_info($clientID, $bCache, $dpuID);
				$grandClientExchangeInfo = false;
			}
			
			if ($exchangeInfo !== false) {
				$xml->push("root");
				foreach ($exchangeInfo as $item) {
					$xml->push('Database', array("Identification" => $item['instance_id'],
														 "Name" => $item['name']));
														 
					// test if dpu has priority/sync functionality, if not return -1	
					if ($bIsSupported) {
						if (isset($item['priority'])) {
							$priority = $item['priority'];
							$xml->element('Priority', $priority);
						}
						if (isset($item['is_synchable'])) {
							$xml->element('Synchable', $item['is_synchable'] ? '1' : '0');
						}
					}
					if (isset($item['wvf'])) {
						$xml->element('WVF', $item['wvf'] ? '1' : '0');
					}
					$xml->pop(); // Database
				}
				$xml->element('Supported', $bIsSupported == true ? 1 : 0);
				$xml->pop();
			} else if ($grandClientExchangeInfo !== false) {
				$xml->push("root");
				foreach ($grandClientExchangeInfo as $item) {
					$xml->push('Database', array("Identification" => $item['instance_id'],
														 "Name" => $item['name']));
					$xml->pop(); // Database
				}
				$xml->element('Supported', $bIsSupported == true ? 1 : 0);
				$xml->pop();				
			} else {
				$BP->buildResult($xml, false);
			}
								
			echo($xml->getXml());			
			break;
			
	case "target":	// list recovery targets
			$clientID = isset($_GET['cid']) ? (int)$_GET['cid'] : -1;
			$database = isset($_GET['db']) ? $_GET['db'] : "";
			$bAll = isset($_GET['all']) ? $_GET['all'] == '1' : true;
			$exchangeInfo = $BP->get_exchange_restore_targets($clientID, $database, $bAll, $sysID);
			if ($exchangeInfo !== false) {
				$xml->push("root");
				foreach ($exchangeInfo as $recoveryItem) {
					$name = $recoveryItem['name'];
					$bMounted = $recoveryItem['mounted'];
					$bWritable = $recoveryItem['writable'];
					$bRecovery = $recoveryItem['recovery'];
					$xml->push('Database', array("Name" => $name));
					$xml->element('Mounted', $bMounted ? '1' : '0');
					$xml->element('Writable', $bWritable ? '1' : '0');
					$xml->element('Recovery', $bRecovery ? '1' : '0');
					$xml->pop();
				}
				$xml->pop();
			} else {
				$BP->buildResult($xml, false);
			}
								
			echo($xml->getXml());			
			break;

}



$BP->destroyCookie();
?>
