<?php

// defines BP, xml, action, cookie
require 'header.php';

//
// Standard URL variables for system, client, virtual client IDs.
//
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

// Get Logging options
$logLevel = (int)$BP->get_ini_value('CMC', 'LogLevel', $dpuID);
$logDirectory = LOG_DIRECTORY;

// Create standard objects for use in all functions.
$Log = new Logger($logLevel, $logDirectory);

//
// .ini settings that determines if GFS is configured
//
define("GFS_SECTION", "GFS");
define("ENABLE", "Enable");
define("DAILY", "Daily");
define("MONTHLY", "Monthly");
define("YEARLY", "Yearly");
define("GFS_DAYS", 0);
define("GFS_MONTHS", 1);
define("GFS_YEARS", 2);

$enabled = $BP->get_ini_value(GFS_SECTION, ENABLE, $dpuID);
if ($enabled !== false) {
	$enabled = strtolower($enabled);
	if ($enabled == 'true') {

		$getLastGroup = 0;
		// Get the daily, monthly and yearly settings from master.ini file
		$daily = (int)$BP->get_ini_value(GFS_SECTION, DAILY, $dpuID);
		$monthly = (int)$BP->get_ini_value(GFS_SECTION, MONTHLY, $dpuID);
		$yearly = (int)$BP->get_ini_value(GFS_SECTION, YEARLY, $dpuID);
		
		$instances = $BP->get_gfs_instance_list();
		if ($instances !== false) {
			foreach($instances as $instance) {		
				// Get upper limit of backup_no(s) for this instance.
				$instance_array = array();
				$instance_array[] = $instance['instance_id'];
				$ret =  bp_get_last_backup_per_instance($instance_array);
				if ($ret === false) {
					$ulimit_backup_no  = 0;
				}  if ($ret === NULL) {
					$ulimit_backup_no  = 0;
				} else {
					$ulimit_backup_no  = $ret[0]['backup_id'];
				}
				// Get the daily, monthly and yearly recovery points
				$daily_rp = $BP->get_gfs_rp(GFS_DAYS, $daily, $instance['instance_id']);
				$monthly_rp = $BP->get_gfs_rp(GFS_MONTHS, $monthly, $instance['instance_id']);
				$yearly_rp = $BP->get_gfs_rp(GFS_YEARS, $yearly, $instance['instance_id']);
						
				if ($daily_rp === false || $daily_rp === NULL) { 
					$daily_rp = array();	
				}
				if ($monthly_rp == false || $monthly_rp === NULL) {
					$monthly_rp = array();
				}
				if ($yearly_rp === false || $yearly_rp === NULL) {
					$yearly_rp = array();
				}
				
				$backupArr = array();
				$backupArr = array_merge($backupArr, $daily_rp, $monthly_rp, $yearly_rp);
				$backups = array();
				foreach ($backupArr as $backup) {
					$backups[] = $backup['backup_no'];
				}
				if (count($backups) > 0 ) {
					$enforceGFS = $BP->enforce_gfs($backups, $instance['instance_id'], $getLastGroup, $ulimit_backup_no);
				} elseif ($daily !== 0 || $monthly !== 0 || $yearly !== 0) {
					// when there are no backups in the specified time range, set 'getLastgroup' so that the last successful backup group is retained
					$getLastGroup = 1;
					$enforceGFS = $BP->enforce_gfs($backups, $instance['instance_id'], $getLastGroup, $ulimit_backup_no);
				} else {
					return;
				} 
				if (isset($enforceGFS) && $enforceGFS === false) {
					$Log->writeError($BP->getError(), true);
				}
			}
		} else {
    		$Log->writeError($BP->getError(), true);
		}
	}
} else {
    $Log->writeError($BP->getError(), true);
}

$BP->destroyCookie();
?>
