<?php
// defines BP, xml, action, cookie
require 'header.php';

define("HYPERV_API_KEY_SUPPORTS_WIR", "supports_wir");
define("HYPERV_API_KEY_SUPPORTS_EFI", "supports_efi");
define("HYPERV_API_KEY_SUPPORTS_2TBDRIVES", "supports_2tb_plus_drives");
define("HYPERV_FILTER_KEY_WIR", "filterwir");
define("HYPERV_FILTER_KEY_EFI", "filterefi");
define("HYPERV_FILTER_KEY_2TBDRIVES", "filterdisks");

define("MAX_FUSES_ALLOWED", 100);

$localID = $BP->get_local_system_id();
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $localID;

// figure out which sysID to used based on view.
$sysID = $grandClientView ? $localID : $dpuID;

global $Log;

switch ($action) {

	case "list":	// list hyperv information for this application (server id).
					// The app ID in this case is the UUID and thus a string (don't cast to int).
			$uuid = isset($_GET['aid']) ? $_GET['aid'] : -1;
			$clientID = isset($_GET['cid']) ? (int)$_GET['cid'] : -1;
			$bCache = isset($_GET['cache']) ? true : false;
			$bIsSupported = $BP->is_appconfig_supported( $dpuID );
			
			if ($grandClientView) {
				$grandClientHypervInfo = $BP->get_grandclient_hyperv_info( $clientID );
				$hypervInfo = false;
			} else {
				$hypervInfo = $BP->get_hyperv_info( $clientID, $bCache, $dpuID );
				$grandClientHypervInfo = false;
			}
			
			
			//$sanDirectInfo = $BP->get_is_san_direct( $clientID, $uuid, $dpuID );
						
			if ($hypervInfo !== false) {
				$xml->push("root");
				foreach ($hypervInfo as $hyperv) {
					$id = $hyperv['instance_id'];
					$name = $hyperv['name'];
					$guid = $hyperv['guid'];
					
					/*
					$sanDirectFlag = 0;
					foreach ( $sanDirectInfo as $key => $sanDirectSupport ) {
						if ( $sanDirectSupport[ "instance_id" ] == $id ) {
							$sanDirectFlag = $sanDirectSupport[ "sandirect_flag" ];
							unset( $sanDirectInfo[ $key ] );
							$Log->writeVariable( "Found instance" );
							break;
						}
					}
					
					*/
					
					if(array_key_exists('cluster_name', $hyperv)){
						$clusterName = $hyperv['cluster_name'];
					} else {
						$clusterName = "";
					}
					
					$isSavedState = $hyperv['is_saved_state'];
					$isStandalone =  $hyperv['is_standalone'];
					
					$clientInfo = $BP->get_client_info($clientID, $dpuID);
					$cluster = $clientInfo['is_hyperv_cluster'];
					
					$xml->push('HYPERV', array("Identification" => $id,
											"Name" => $name,
											"guid" => $guid,
											"clusterName" => $clusterName,
											"isCluster" => $cluster,
											"isSavedState" => $isSavedState,
											"isStandalone" => $isStandalone ));
											
					/*
					$xml->push('HYPERV', array("Identification" => $id,
											"Name" => $name,
											"guid" => $guid,
											"clusterName" => $clusterName,
											"isCluster" => $cluster,
											"isSavedState" => $isSavedState,
											"isStandalone" => $isStandalone,
											"sanDirect" => $sanDirectFlag ));
					 */
					
					if (isset($hyperv['model'])) {
						$modelType = $hyperv['model'] == 'full' ? "Full" : "All";
						$xml->element('Model', $modelType);
					}
					if (isset($hyperv['is_running'])) {
						$xml->element('Running', $hyperv['is_running'] ? '1' : '0');
					}
		
					// test if dpu has priority/sync functionality, if not return -1			
					if ($bIsSupported) {
						if (isset($hyperv['priority'])) {
							$priority = $hyperv['priority'];
							$xml->element('Priority', $priority);
						}
						if (isset($hyperv['is_synchable'])) {
							$xml->element('Synchable', $hyperv['is_synchable'] ? '1' : '0');
						}
					} else {
						$xml->element('Priority', '-1');
					}
					$xml->pop(); // VM
				}
				$xml->element('Supported', $bIsSupported == true ? 1 : 0);
				$xml->pop(); // root
			} else if ($grandClientHypervInfo !== false)  {
				$xml->push("root");
				foreach ($grandClientHypervInfo as $hyperv) {
					$id = $hyperv['instance_id'];
					$name = $hyperv['name'];
					$guid = $hyperv['guid'];
					
					$xml->push('HYPERV', array("Identification" => $id,
											"Name" => $name,
											"guid" => $guid, ));
					$xml->pop(); // VM
				}
				
				$xml->element('Supported', $bIsSupported == true ? 1 : 0);
				$xml->pop(); // root
			} else {
				$BP->buildResult($xml, false);
			}
								
			echo($xml->getXml());			
			break;
			
	case "state":
	
		$instanceID = isset($_GET['id']) ? (int)$_GET['id'] : -1;
		$clientID = isset($_GET['cid']) ? (int)$_GET['cid'] : -1;
		
		$recoveryStateInfo = $BP->get_hyperv_recovery_state($clientID, $instanceID, $sysID);
		
		if($recoveryStateInfo !== false && $recoveryStateInfo != NULL) {
			$xml->push('root');
			$state = $recoveryStateInfo;
			$attibutes = array('Owner' => $state['owner'], 'VSSW' => $state['vssw'], 'Orig' => $state['orig'], 'msg' => $state['msg'] );
			$xml->emptyelement('State', $attibutes);
			
			/*foreach ($recoveryTargetInfo as $target) {
					$attibutes = array('Owner' => $target['owner'], 'VSSW' => $target['vssw'], 'Orig' => $target['orig']);
					$xml->emptyelement('Target', $attibutes);
			}*/
			$xml->pop(); //root
				
		} else {
			$BP->buildResult($xml, false);
		}
		
		echo($xml->getXml());			
		break;	
	
	case "flClients":
		$backupID = isset($_GET['bid']) ? (int)$_GET['bid'] : -1;
		
		$hypervClients = $BP->get_hyperv_fl_recovery_clients($backupID, $sysID);
		
		$clients = array();
		if($hypervClients !== false) {
			$xml->push('root');
			foreach ($hypervClients as $clientID => $clientName) {
				$xml->push("client");
				$xml->element("id", $clientID);
				$xml->element("name", $clientName);
				$xml->pop();
			}
			$xml->pop(); //root
		} else {
			$BP->buildResult($xml, false);
		}
		
		echo($xml->getXml());			
		break;	
		
	case "group":
		$backupID = isset($_GET['bid']) ? (int)$_GET['bid'] : -1;
		
		$restoreGroup = $BP->get_restore_group($backupID, $sysID); 
		
		if($restoreGroup !== false){
			$BP->buildResult($xml, true);
		} else {
			$BP->buildResult($xml, false);
		}
		
		echo($xml->getXml());			
		break;	
		
	case "recovery_clients":
	
		$instanceID = isset($_GET['id']) ? (int)$_GET['id'] : -1;
		
		$hypervClients = $BP->get_hyperv_recovery_clients($instanceID, $sysID);
		
		$clients = array();
		if($hypervClients !== false) {
			$xml->push('root');
			foreach ($hypervClients as $clientID => $clientName) {
				$xml->push("client");
				$xml->element("id", $clientID);
				$xml->element("name", $clientName);
				$xml->pop();
			}
			$xml->pop(); //root
		} else {
			$BP->buildResult($xml, false);
		}
	
		echo($xml->getXml());			
		break;
	
	case "set_san_direct":
		$clientID       = isset($_GET['cid']) ? (int)$_GET['cid'] : -1;
		$uuid           = isset($_GET['aid']) ? (int)$_GET['aid'] : -1;
		$idsAndStatuses = isset($_GET['ins']) ? $_GET['ins'] : -1;
		
		$Log->writeVariable( "clientID = $clientID, uuid = $uuid, idsAndStatuses = $idsAndStatuses" );
		
		if ( $idsAndStatuses != -1 ) {
			$idStatuses = explode(",", $idsAndStatuses );
			
			$sanDirectSupport = array();
			foreach ( $idStatuses as $key => $idStatus ) {
				$inst = explode( "_", $idStatus );
				$sanDirectSupport[ $key ] [ "instance_id" ]    =  (int)$inst[0];
				$sanDirectSupport[ $key ] [ "sandirect_flag" ] =  (int)$inst[1] ;
			}
			
			
			
			$Log->writeVariable( "SAN Direct Support:" );
			$Log->writeVariable( $sanDirectSupport );
			
			if ( count( $sanDirectSupport ) > 0 ) {
				$Log->writeVariable( "Setting the value for San Direct");
				
				$result = $BP->set_is_san_direct( $clientID, $uuid, $sanDirectSupport, $sysID );
			} else {
				$result = false;
			}
			if ( $result !== false ) {
				$xml->push('root');
				$xml->element("Result", 1 );
				$xml->pop(); //root
			} else {
				$BP->buildResult($xml, false);
			}
		}
		echo($xml->getXml());
		break;
		
	case "target": 
		//List the available Hyper-V servers 
		$osID = isset($_GET['osid']) ? (int)$_GET['osid'] : -1;
		
		$filter = array();
			// WIR filter. If set, only return ESX servers that support WIR
		$filter[HYPERV_API_KEY_SUPPORTS_WIR] = isset($_REQUEST[HYPERV_FILTER_KEY_WIR]) ? ($_REQUEST[HYPERV_FILTER_KEY_WIR] == '1') : false; 
			// EFI filter. If set, only return ESX servers that support EFI
		$filter[HYPERV_API_KEY_SUPPORTS_EFI] = isset($_REQUEST[HYPERV_FILTER_KEY_EFI]) ? ($_REQUEST[HYPERV_FILTER_KEY_EFI] == '1') : false; 
			// Disk filter. If set, only return ESX servers that support >2TB disks
		$filter[HYPERV_API_KEY_SUPPORTS_2TBDRIVES] = isset($_REQUEST[HYPERV_FILTER_KEY_2TBDRIVES]) 
													? ($_REQUEST[HYPERV_FILTER_KEY_2TBDRIVES] == '1') : false;

		$hyperVInfo = $BP->get_hyperv_servers_for_wir($osID, $sysID);	
		if ($hyperVInfo !== false) {
			$xml->push("root");
			if (isset($hyperVInfo['warning'])) {
				$xml->element('Warning', $hyperVInfo['warning']);
			}
			if (is_array($hyperVInfo) && count($hyperVInfo) > 0) {
				foreach ($hyperVInfo as $hyperV) {
					$name = $hyperV['name'];
					$clientID = $hyperV['client_id'];
					$application = $hyperV['application'];
						
					$capabilities = $hyperV['capabilities'];
					$isCluster = isset ($capabilities['is_cluster'] )? $capabilities['is_cluster'] : false;
						
					if (isset($hyperV['capabilities'])) {
						$filterOutServer = shouldFilterOutServer($filter, $hyperV['capabilities']);
							//$Log->writeVariable("hyperv_log: name - $name, skip - $skipThisServer");
						if ($filterOutServer == true) {
							continue;
						}
					}
					$xml->push('HYPERV', array("Name" => $name, "ClientID" => $clientID ,
												"Application" => $application , "Cluster" => $isCluster ? '1' : '0'));
						
					$xml->pop(); // HyperV
				}
			}
			$xml->pop();
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());			
		break;
		
	case "storage": 
		//List the storage
		$clientID = isset($_GET['hypervcid']) ? (int)$_GET['hypervcid'] : -1;

		$hyperVStorageInfo = $BP->get_hyperv_storage($clientID, $sysID);	
		if ($hyperVStorageInfo !== false) {
			$xml->push("root");
			if (isset($hyperVStorageInfo['warning'])) {
				$xml->element('Warning', $hyperVStorageInfo['warning']);
			}
			if (is_array($hyperVStorageInfo) && count($hyperVStorageInfo) > 0) {
				foreach ($hyperVStorageInfo as $hyperVStorage) {
					$path = $hyperVStorage['name'];
					$size = $hyperVStorage['mb_size'];
					$free = $hyperVStorage['mb_free'];
			
					$xml->push('Storage', array("Name" => $path, "id" => $path, "Size" => $size, "Free" => $free,
													"isBranch" => "true"));
						
					$xml->pop(); // Storage
				}
			}
			$xml->pop();
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());			
		break;
	
	case "ir_support":
		$result = $BP->hyperv_ir_supported($sysID);
		$xml->push('root');
		$xml->element('HyperVIRSupported', $result == true ? "1" : "0");
		$xml->pop(); // root
		echo($xml->getXml());
		break;
		
	case "ir_servers": 
		//List the targets for IR
		$instanceID = isset($_GET['id']) ? (int)$_GET['id'] : -1;

		$hyperVIRInfo = $BP->get_hyperv_servers_for_ir($instanceID, $sysID);	
		if ($hyperVIRInfo !== false) {
			$xml->push("root");
			if (isset($hyperVIRInfo['warning'])) {
				$xml->element('Warning', $hyperVIRInfo['warning']);
			}
			if (is_array($hyperVIRInfo) && count($hyperVIRInfo) > 0) {
				foreach ($hyperVIRInfo as $hyperVIR) {
					$name = $hyperVIR['name'];
					$client_id = $hyperVIR['client_id'];
					$app = $hyperVIR['application'];
					$is_cluster = $hyperVIR['is_cluster'];
			
					$xml->push('HYPERV', array("Name" => $name, "ClientID" => $client_id ,
												"Application" => $app , "Cluster" => $is_cluster ? '1' : '0'));
						
					$xml->pop(); // HYPERV
				}
			}
			$xml->pop();
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());			
		break;
				
	case "start": //start hyperv instant recovery  
			$HVclientName       = isset($_GET['hyperv'] ) ? $_GET['hyperv']		: "";
			$vmName         	= isset($_GET['name']) ? $_GET['name']     		: "";
			$storage_location   = isset($_GET['loc'] ) ? $_GET['loc']       	: "";
			$restoreAddress 	= isset($_GET['add'] ) ? $_GET['add']       	: "";
			$audit          	= isset($_GET['aud'] ) ? (int)$_GET['aud']  	:  0;
			$backups        	= isset($_GET['bks'] ) ? $_GET['bks']       	: "";
			$poweron         	= isset($_GET['power']) ? (int)$_GET['power'] 	: 1;
			$switch				= isset($_GET['switch']) ? $_GET['switch'] 		: NULL;
			
			$hvIRStartResult = $BP->hyperv_ir_start($HVclientName, $vmName, $storage_location, $restoreAddress, $audit, $backups, $poweron, $switch, $sysID );
			
			if ($hvIRStartResult !== false) {
				$xml->push("root");
				$xml->element('Result', $hvIRStartResult);
				$xml->pop(); //root
			} else {
				$BP->buildResult($xml, false);
			}					
			echo($xml->getXml());			
			break;

	case "destroy":  //destroy hyperv instant recovery job
			$iID = isset($_GET['id']) ? (int)$_GET['id'] : "";
			$force = isset($_GET['force']) ? (int)$_GET['force'] : "";
			
			$hvIRDestroyResult = $BP->hyperv_ir_destroy($iID, $force, $sysID);	
			if ($hvIRDestroyResult !== false) {
				$xml->push("root");
				$xml->element('Result', $hvIRDestroyResult);							
				$xml->pop(); //root
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());			
			break;
		
	case "status": //get hyperv instant recovery status 
			$hvIRStatus = $BP->get_hyperv_ir_status($sysID);	 
			$hv_status_info = array();
			 
			$AppInstance = "";
			$AppItem = "";
							 
			if ($hvIRStatus !== false) {	
				$xml->push("HVIRStatus");
				foreach ($hvIRStatus as $hv_status_info) {	
					$xml->push("VM");
					if (isset($hv_status_info['id'])) {
						$xml->element('ID', $hv_status_info['id']);
						//get name of vm from app inst id
						$appInstName = $BP->get_appinst_name($hv_status_info['id'], $sysID);
						//need to check for existence of "|" if so take it apart							
						$strPipe = "|";
						if (strlen(strstr($appInstName, $strPipe)) > 0) {
							 $InstPart1 = explode("|", $appInstName);
							 $AppInstance = $InstPart1[0];
							 $AppItem = $InstPart1[1];
						}
						$xml->element('VMName', $AppInstance);
						$xml->element('GUID', $AppItem);
					} 					
					if (isset($hv_status_info['status'])) {
						$xml->element('Status', $hv_status_info['status']);
					} 					
					if (isset($hv_status_info['detail'])) {
						$xml->element('Detail', $hv_status_info['detail']);
					} 					
					if (isset($hv_status_info['percentage'])) {
						$xml->element('Percentage', $hv_status_info['percentage']);
					} 
					if (isset($hv_status_info['time'])) {
						$xml->element('Time', $hv_status_info['time']);
					} 
					if (isset($hv_status_info['audit'])) {
						$xml->element('audit', $hv_status_info['audit']);
					} 	
					$xml->pop(); //VM  
				}
				$xml->pop(); //HV IR Status	 
			 } else {
				$BP->buildResult($xml, false);
			 }
			 echo($xml->getXml());	
			 break;
			 
	case "backups":
			// get list of VMs that have backups
			if ($grandClientView) {
				// for replicated backups, either filter to 1 source, specified by 'sid'; if no sid, show all.
				$showAll = !isset($_GET['sid']);
				if ($showAll) {
					// loop through all systems to get replicated VM list.
					$vms = array();
					$systems = $BP->get_system_list();
					foreach ($systems as $id => $name) {
						$sysvms = $BP->get_protected_hyperv_vms(true, $id);
						for ($i = 0; $i < count($sysvms); $i++) {
							$sysvms[$i]['source_id'] = $id;
							$sysvms[$i]['source_name'] = $name;
						}
						$vms = array_merge($vms, $sysvms);
					}
				} else {
					$vms = $BP->get_protected_hyperv_vms(true, $dpuID);
				}
			} else {
				// for non-replicated backups, do not use grand client view.
				$vms = $BP->get_protected_hyperv_vms(false, $dpuID);
			}
			if ($vms !== false) {
				$xml->push('VMs');
				foreach ($vms as $vm) {
					$xml->push('VM');
					$xml->element('Name', $vm['vm_name']);
					$xml->element('ID', $vm['instance_id']);
					if (isset($vm['guest_os'])) {
						$xml->element('OS', $vm['guest_os']);
					}
					$xml->element('GUID', $vm['guid']);
					if (isset($vm['source_id'])) {
						$attrs = array('ID' => $vm['source_id'], 'Name' => $vm['source_name']);
						$xml->emptyElement("Source", $attrs);
					}
					$xml->pop();
				}
				$xml->pop();
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
}

/**
* Capabilities returned :
* supports_wir
* supports_efi
* supports_2tb_plus_drives
*/
function shouldFilterOutServer ($filter, $capabilities) {
	$shouldFilterOutServer = false;
	
	foreach ( $filter as $filterKey=>$filterValue ) {		
		switch ( $filterKey ) {
			case HYPERV_API_KEY_SUPPORTS_WIR:
			case HYPERV_API_KEY_SUPPORTS_EFI:
			case HYPERV_API_KEY_SUPPORTS_2TBDRIVES:
				// Compare filter with capabilities if filter is true/turned on
				// If server does not have given capability, set shouldFilterOutServer to true
				//$Log->writeVariable("filter $filterKey=$filterValue, capabilities=$capabilities[$filterKey]");
				if ($filterValue == true && isset($capabilities[$filterKey]) && $capabilities[$filterKey] != 1) {
					//$Log->writeVariable("shouldFilterOutServer");
					$shouldFilterOutServer = true;
				}
				break;
		}
		
		if ($shouldFilterOutServer == true) {
			break;	
		}
	}
	
	return $shouldFilterOutServer;
}

function xmlToVMs($xml)
{
	$parser = xml_parser_create();
	xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
	xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
	xml_parse_into_struct($parser, $xml, $values, $tags);
	xml_parser_free($parser);

	$returnArray = array();
	$oneVM = array();

	$stack = array();
	$i = 0;
	foreach ($values as $val) {
		if ($val['type'] == "open") {
			if ($val['tag'] != "VMs" && $val['tag'] != "VM") {
				$field = buildFieldName($val['tag']);
				array_push($stack, $field);
			}

		} else if ($val['type'] == "close") {
			if ($val['tag'] != "VMs" && $val['tag'] != "VM") {
				array_pop($stack);
			}
		} else if ($val['type'] == "complete") {
			$field = buildFieldName($val['tag']);
			array_push($stack, $field);
			setArrayValue($oneVM, $stack, $val['value'], false);
		
			array_pop($stack);		
			if ($val['tag'] == 'Synchable') {
				$returnArray[] = $oneVM;
				$oneVM = array();			
			}						
		}
	}
	return $returnArray;	
}

function setArrayValue(&$array, $stack, $value, $bBoolean) {
	if ($stack) {
		$key = array_shift($stack);
		setArrayValue($array[$key], $stack, $value, $bBoolean);
	} else {
		if ($bBoolean) {
			$array = $value == 'true' ? true : false;
		}else {
			$array = $value;
		}
	}
}

function buildFieldName($tag)
{
	$field = "";

	switch ($tag) {
		case "Name":
			$field = "Name";
			break;
		
		case "ID":
			$field = "Identification";
			break;
		
		case "Priority":
			$field = "Priority";
			break;
			
		case "Synchable":
			$field = "Synchable";
			break;
	}		
	return $field;
}

$BP->destroyCookie();
?>
