<?php
// defines BP, xml, action, cookie
require 'header.php';

$localID = $BP->get_local_system_id();
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $localID;

$clientID = isset($_GET['cid']) ? (int)$_GET['cid'] : -1;
$bCache = isset($_GET['cache']) ? true : false;

// figure out which sysID to used based on view.
$sysID = $grandClientView ? $localID : $dpuID;

switch ($action) {

	case "list":	// list NDMP Volume information
			global $Log;
			
			$Log->writeVariable( "NDMP List called");

			$ndmpGCVInfo = false;
			$ndmpInfo    = false;

			if ($grandClientView) {
				$ndmpGCVInfo = $BP->get_grandclient_ndmpvolume_info( $clientID );
			} else {
				$ndmpInfo = $BP->get_ndmpvolume_info( $clientID, $bCache, $sysID );
			}

			$Log->writeVariable( $ndmpInfo );
			
			if ($ndmpInfo !== false) {
				$xml->push("root");
				foreach ( $ndmpInfo as $item ) {
					$xml->push('Volume', array("Identification" => $item['instance_id'],
														 "Name" => $item['name']));

					if ( isset( $item['is_online'] ) )   $xml->element('Online',         $item['is_online']   ? "1" : '0' );
					if ( isset( $item['is_synchable'] ) ) $xml->element('Synchable',      $item['is_synchable'] ? "1" : '0' );
					
					if ( isset( $item['priority'] ) )    $xml->element('Priority', 		 $item['priority'] );
					if ( isset( $item['fs_type'] ) )     $xml->element('FileSystemType', $item['fs_type'] );
					if ( isset( $item['size'] ) )        $xml->element('TotalSize',      $item['size'] );
					if ( isset( $item['used'] ) )        $xml->element('UsedSize',       $item['used'] );
					if ( isset( $item['avail'] ) )       $xml->element('AvailableSize',  $item['avail'] );


					$xml->pop(); // Volume
				}
				// This lets the App know that item replication configuration is supported.
				$xml->element('Supported', 1);
				$xml->pop();

			} else if ($ndmpGCVInfo !== false) {
				$xml->push("root");
				foreach ($ndmpGCVInfo as $item) {
					$xml->push('Volume', array("Identification" => $item['instance_id'],
														 "Name" => $item['name']));

					if ( isset( $item['fs_type'] ) )
						$xml->element('FileSystemType', $item['fs_type'] );

					$xml->pop(); // Volume
				}
				$xml->pop(); //root				
			} else {
				$Log->writeVariable( "Error occurred with NDMP");
				$BP->buildResult($xml, false);
			}

			$Log->writeVariable( "NDMP Volumes Listed");
								
					
			break;
			
	case "target":	// list recovery targets
	
			global $Log;
			
			$Log->writeVariable( "NDMP Target called");
			
			$backupID = (int)$_GET['backupID'];
			
			$Log->writeVariable( "The NDMP backup id is ".$backupID );
			
			$targets = $BP->get_ndmp_restore_targets($backupID, $sysID);
			
			$Log->writeVariable( "The targets are ".$targets );
			
			if($targets !== false) {
				$xml->push('root');
				$targetKeys = array_keys($targets);
				foreach ($targetKeys as $target) {
					$xml->push('Target');
					
					$xml->element('ID', $target);			
					
					if(isset($targets[$target])) {
						$xml->element('Name', $targets[$target]);
					}
					$xml->pop(); //Target
				}
				$xml->pop(); //root
			} else {
				$Log->writeVariable( "Error with getting restore targets for NDMP");
				$BP->buildResult($xml, false);
			}
			
			$Log->writeVariable( "NDMP Targets listed");
			
			break;
		
		case 'volume':
			
			global $Log;
			
			$Log->writeVariable( "NDMP Target called");
			
			$backupID = (int)$_GET['backupID'];
			
			$NASID = (int)$_GET['NASID'];
			
			$Log->writeVariable( "The NDMP backup id is ".$backupID );
			$Log->writeVariable( "The NASID is " .$NASID );
			
			$volumes = $BP->get_ndmp_restore_target_volumes($NASID, $backupID, $sysID);
			
			$Log->writeVariable( "The volumes are ".$volumes );
			
			if($volumes !== false) {
				$xml->push('root');
				
				foreach ($volumes as $volume) {
					$xml->push('Volume');

					if(isset($volume['instance_id'])) {
						$xml->element('instance_id', $volume['instance_id']);			
					}
					if(isset($volume['name'])) {
						$xml->element('Name', $volume['name']);
					}
					if(isset($volume['fs_type'])) {
						$xml->element('fs_type', $volume['fs_type']);			
					}
					if(isset($volume['is_online'])) {
						$xml->element('is_online', $volume['is_online']);			
					}
					if(isset($volume['used'])) {
						$xml->element('used', $volume['used']);			
					}
					if(isset($volume['size'])) {
						$xml->element('size', $volume['size']);			
					}
					if(isset($volume['avail'])) {
						$xml->element('avail', $volume['avail']);			
					}
					
					$xml->pop(); //Volume
				}
				$xml->pop(); //root
			} else {
				$Log->writeVariable( "Error with getting restore target volumes for NDMP");
				$BP->buildResult($xml, false);
			}
			
			$Log->writeVariable( "NDMP Target Volumes listed");
			break;
}

print($xml->getXml());	


$BP->destroyCookie();
?>
