<?php

//**************************************
//hybrid of allschedules.php and schedules.php
//incomplete implementation
//**************************************

// defines BP, xml, action, cookie
require 'header.php';

// xml reader operations for clients.
require 'xmlreader.php';

// list base functions
require 'listsbase.php';
$ListBase = new ListBase();

// general library functions
require 'library.php';
$lib = new Library();

// Initialize variables to be used in save.
$scheduleInfo = array();
$bValid = true;

switch ($action) {

	case "list":
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			listSchedulesForAllSystems($BP, $xml, $dpuID);
			echo($xml->getXml());
			break;
	
	case "detail":
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			$id = (int)$_GET['id'];
			$xml->push('root');
			buildInclExclLists($BP, $xml, $id, $dpuID);
			$xml->pop(); // root
			echo($xml->getXml());
			break;
}

function listSchedulesForAllSystems ($BP, $xml, $dpuID) {	
		// Loop through all systems.  Will be only one in the list for a DPU, multiple systems on a Vault.
		$systems = $BP->get_system_list();
		
		if ($systems === false) {
			$BP->buildResult($xml, false);
			echo($xml->getXml());
			return;
		}
		
		$localID = $BP->get_local_system_id();
		$bVault = $BP->local_system_is_vault();
			
		$bManager = $BP->local_system_is_mgr();
		$bMDPU = isset($_GET['mdpu']) ? true : false;
		
		// If an error occurs, skip this DPU and continue.
		$xml->push('root');
		foreach ($systems as $systemID => $systemName) {
			if ($systemID == $dpuID || $dpuID == $localID) {
				// If this system is a vault and we are looking at this system, skip it and go to the next.
				if ($bVault && ($systemID == $localID)) {
					continue;
				}
				// If this system is a manager and we are not running on the MDPU node nor are
				// not looking at the selected system, skip it.
				if (!$bVault && $bManager && !$bMDPU && ($systemID != $dpuID)) {
					continue;
				}			
				
				buildScheduleList($BP, $xml, $systemID, $systemName);
				buildAppScheduleList($BP, $xml, $systemID, $systemName);				
			}
		}
		$xml->pop(); // end root
}

// NOT USED?
// This function lists the schedules for this client and application, optionally loading each schedule.
//
function listSchedules($BP, $xml, $cid, $aid, $dpuID, $bLoad = false)
{
	global $ListBase;
	global $Log;
	
	$clients = ($cid === -1) ? $BP->get_client_list($dpuID) : false;
	$scheduleList = $BP->get_app_schedule_list($cid, $aid, $dpuID);
	if ($scheduleList !== false) {
		$xml->push("root");
		foreach ($scheduleList as $schedule) {
		  $attributes = $ListBase->getAttributes($schedule);	
			if (array_key_exists('enabled', $schedule)) {
				$enabled = $schedule['enabled'] == true ? "1" : "0";
				$attributes['Enabled'] = $enabled;
			}
			
			$Log->writeVariable($enabled);
			
			if (array_key_exists('client_id', $schedule)) {
				$clientID = $schedule['client_id'];
				$clientName = $clients !== false ? $clients[$clientID] : $clientID;
				$attributes['Client'] = $clientName;
			}
			// handle vCenter schedules.
			if (array_key_exists('esx_uuid', $schedule)) {
				$uuid = $schedule['esx_uuid'];
				$attributes['UUID'] = $uuid;
			}
			$xml->push("Schedule", $attributes);
			if ($bLoad) {
				loadSchedule($BP, $xml, $schedule['id'], $dpuID, false);
			}
			$xml->pop(); // schedule
		}
		$xml->pop(); // root
	} else {
		$BP->buildResult($xml, false);
	}
}

//
// This function loads the schedule given its ID.  It optionally wraps the schedule
// information with a root XML tag.
//
function loadSchedule($BP, $xml, $id, $dpuID, $bShowRoot = true)
{
	$scheduleInfo = $BP->get_app_schedule_info($id, $dpuID);
	if ($scheduleInfo !== false) {
		if ($bShowRoot) {
			$xml->push("root");
		}
		
		if ($bShowRoot) {
			$BP->buildResult($xml, false);
		} else {
			// Add a warning that this schedule could not be loaded.
			;
		}
	}
}
	
//
// This function walks the schedule information returned from the load and
// creates the XML for each element.
// This includes: get_schedule_list + get_schedule_info
//
function buildScheduleList($BP, $xml, $dpuID, $systemName) {
	global $Log;
	
	$scheduleList = $BP->get_schedule_list($dpuID);
	if ($scheduleList !== false) {
		foreach ($scheduleList as $schedule) {
			if (array_key_exists('enabled', $schedule)) {
				$enabled = $schedule['enabled'];
			}
			if ($enabled) {
				if(array_key_exists('id', $schedule)){
					$SchedID = $schedule['id'];
				}
				$scheduleInfo = $BP->get_schedule_info($SchedID, $dpuID);
				if ($scheduleInfo !== false) {
					if(array_key_exists('clients', $scheduleInfo)) {
						$clientList = $scheduleInfo['clients'];
						foreach ($clientList as $clients) {
							$xml->push("Schedule");
							if ($systemName) {
								$xml->element("SystemName", $systemName);
							}	
							if (array_key_exists('id', $clients)) {
								$clientID = $clients['id'];
								$xml->element('ClientID', $clientID);
							}
							$clientInfo = $BP->get_client_info($clientID, $dpuID);
							// TODO do we need to filter out schedules for disabled clients?
							if (array_key_exists('name', $clientInfo)){
								$clientName = $clientInfo['name'];
								$xml->element("ClientName", $clientName);
							}
							if(array_key_exists('name', $schedule)){
								$SchedName = $schedule['name'];
								$xml->element("Name", $SchedName);
							}
							if(array_key_exists('description', $schedule)){
								$schedDescription = $schedule['description'];
								$xml->element("Description", $schedDescription);
							}
							
							if (array_key_exists('run_only', $schedule)) {
								$runOnly = $schedule['run_only'] == true ? "1" : "0";
							}
							if (isset($scheduleInfo['calendar'])) {
								$iCalendarContent = $BP->get_calendar($scheduleInfo['calendar'], $dpuID);
								if ($iCalendarContent !== false) {
									$xml->push("Calendar");
									$xml->cData($iCalendarContent);
									$xml->pop(); // Calendar	
								}
							}
							// TODO could be array for split lists
							if (isset($clients['inclusions'])) {
								$selectionListID = $clients['inclusions'];
								// TODO optimize to see if we already called this before
								$list = $BP->get_selection_list($selectionListID);
								if ( $list !== false && isset($list['filenames']) ) {
									$filenames = $list['filenames'];
									getInclusionExclusionXML($xml, $filenames, 'InclusionList', 'Item');
								}
							}
							// TODO could be array for split lists
							if (isset($clients['exclusions'])) {
								$selectionListID = $clients['exclusions'];
								// TODO optimize to see if we already called this before
								$list = $BP->get_selection_list($selectionListID);
								if ( $list !== false && isset($list['filenames']) ) {
									$filenames = $list['filenames'];									
									getInclusionExclusionXML($xml, $filenames, 'ExclusionList', 'Item');
								}
							}
							getLegalHold($BP, $xml, $dpuID, $clientID);
							$xml->pop(); // Schedule
						}
					}
				}
			}
		}
	}
}

//
// Builds the inclusion and exclusions lists for a particular schedule.
//
function buildInclExclLists($BP, $xml, $id, $dpuID) {
	$appScheduleInfo = $BP->get_app_schedule_info($id, $dpuID);
	if ($appScheduleInfo === false) {
		$appScheduleInfo = $BP->get_rae_app_schedule_info($id, $dpuID);
	}
	
	if ($appScheduleInfo !== false) {
		$appSchedOptions = $appScheduleInfo['backup_options'];
	}
	
	if (array_key_exists('excl_list', $appSchedOptions)) {
		$filenames = $appSchedOptions['excl_list'];
		foreach ($filenames as $fileName) {
			$xml->push("Exclusions");
			// For Linux directories, remove the volume placeholder.
			$fileName = str_replace(LINUX_VOLUME, "", $fileName); 
			$xml->element("Exclude", $fileName);
			$xml->pop(); // Exclusions
		}
	}
	
	if (array_key_exists('incl_list', $appSchedOptions)) {
		$filenames = $appSchedOptions['incl_list'];
		foreach ($filenames as $fileName) {
			$xml->push("Inclusions");
			// For Linux directories, remove the volume placeholder.
			$fileName = str_replace(LINUX_VOLUME, "", $fileName); 
			$xml->element("Include", $fileName);
			$xml->pop(); // Inclusions
		}
	}
}


//
// Creates the XML information for the application schedule list.
// This includes: get_app_schedule_list + one of get_app_schedule_info or get_rae_app_schedule_info
//
function buildAppScheduleList($BP, $xml, $dpuID, $systemName) {
	global $Log;

	$cid = isset($_GET['cid']) ? (int)$_GET['cid'] : -1;
	$aid = isset($_GET['aid']) ? (int)$_GET['aid'] : -1;

	$appScheduleList = $BP->get_app_schedule_list($cid, $aid, $dpuID);
	if ($appScheduleList !== false){
		foreach ($appScheduleList as $appschedule) {	
			if (array_key_exists('enabled', $appschedule)) {
				$enabled = $appschedule['enabled'];
			}
			if ($enabled) {
				if (array_key_exists('id', $appschedule)) {
					$schedID = $appschedule['id'];
				}
				$appScheduleInfo = $BP->get_app_schedule_info($schedID, $dpuID);
				if ($appScheduleInfo === false) {
					$appScheduleInfo = $BP->get_rae_app_schedule_info($schedID, $dpuID);
				}
				if ($appScheduleInfo !== false) {
					$appSchedOptions = $appScheduleInfo['backup_options'];
				}
				if(array_key_exists('appinst_ids', $appSchedOptions)) {
					$appInstIDs = $appSchedOptions['appinst_ids'];
					$items = count($appInstIDs);
					for ($i=0; $i < $items; $i++){
						$xml->push("AppSchedule");
						$appInstID = (int)$appInstIDs[$i];
						$xml->element("AppInstID", $appInstID);
						
						$appName = "";
						$appNameArray = $BP->get_application_clients($appInstID, $dpuID);
						if ($appNameArray !== false){
							if (array_key_exists('app_name', $appNameArray)) {
								$appName = $appNameArray['app_name'];
								$xml->element("AppName", $appName);
							}
						}
						
						$appInstName = $BP->get_appinst_name($appInstID, $dpuID);
						if ($appInstName !== false) {
							$instName = processInstanceName( $appInstName, $appName, "" ) ;
							$xml->element("AppInstName", $instName);
						}				
					
						buildAppScheduleDetails ($BP, $xml, $appschedule, $appScheduleInfo, $appSchedOptions, $dpuID, $systemName, $appInstID);
						//get retention settings for the report - legal hold, min retention, max retention
						//getLegalHold($BP, $xml, $dpuID, $clientID, $appID);
		
						$xml->pop(); // appschedule
					}
				} else {
					$xml->push("AppSchedule");
					buildAppScheduleDetails ($BP, $xml, $appschedule, $appScheduleInfo, $appSchedOptions, $dpuID, $systemName);
					//getLegalHold($BP, $xml, $dpuID, $clientID, $appID);
					$xml->pop(); // appschedule
				}
			}
		}
	}
}

//
// Creates detailed XML information a specific application schedule.
//
function buildAppScheduleDetails($BP, $xml, $appschedule, $appScheduleInfo, $appSchedOptions, $dpuID, $systemName, $appInstID = NULL) {
	if ($systemName) {
		$xml->element("SystemName", $systemName);
	}
	
	if (array_key_exists('name', $appschedule)) {
		$Name = $appschedule['name'];
		$xml->element("Name", $Name);
	}
	if (array_key_exists('description', $appschedule)) {
		$description = $appschedule['description'];
		$xml->element("Description", $description);
	}	
	
	if (array_key_exists('client_id', $appschedule)) {
		$clientID = $appschedule['client_id'];
		$xml->element("ClientID", $clientID);
	}
	
	$clientInfo = $BP->get_client_info($clientID, $dpuID);
	if (array_key_exists('name', $clientInfo)){
		$clientName = $clientInfo['name'];
		$xml->element("ClientName", $clientName);
	 }
	
	if (array_key_exists('app_id', $appschedule)) {
		$appID = $appschedule['app_id'];
		$xml->element("AppID", $appID);
	}
	
	if (array_key_exists('id', $appschedule)) {
		$schedID = $appschedule['id'];
		$xml->element("ID", $schedID);
	}
	
	$iCalendarContent = isset($appScheduleInfo['calendar']) ? $appScheduleInfo['calendar'] : false;
	if ($iCalendarContent !== false) {
		$xml->push("Calendar");
		$xml->cData($iCalendarContent);
		$xml->pop(); // Calendar	
	}
	
	if (array_key_exists('excl_list', $appSchedOptions)) {
		$filenames = $appSchedOptions['excl_list'];
		getInclusionExclusionXML($xml, $filenames, 'ExclusionList', 'Item');
	}
	
	if (array_key_exists('incl_list', $appSchedOptions)) {
		$filenames = $appSchedOptions['incl_list'];
		getInclusionExclusionXML($xml, $filenames, 'InclusionList', 'Item');
	}
	getLegalHold($BP, $xml, $dpuID, $clientID, $appID, $appInstID);
}

//
// Get legal hold policy for client or application
// used legalhold.php
//
function getLegalHold($BP, $xml, $dpuID, $clientID, $appID = NULL, $appInstID = NULL) // Call for each client and application
{
	$retention = $BP->get_retention_settings(array('client_id' => $clientID, 'app_id' => $appID, 'instance_id' => $appInstID), $dpuID);
	if ($retention!==false) {
		foreach ($retention as $ret) {
			if ($appID == NULL and $appInstID == NULL) {
				if (isset($ret['app_name'])) {
					if ($ret['app_name'] == 'file-level') {
						$xml->push("Retention");
						$xml->element('AppName', $ret['app_name']);
						if (isset($ret['legal_hold'])) {
							$xml->element('LegalHold', $ret['legal_hold']);
						}
						if (isset($ret['retention_min'])) {
							$xml->element('MinRetention', $ret['retention_min']);
						}
						if (isset($ret['retention_max'])) {
							$xml->element('MaxRetention', $ret['retention_max']);
						}
						$xml->pop(); //Retention
					}
				}
			} else {
				$xml->push("Retention");
				if (isset($ret['legal_hold'])) {
					$xml->element('LegalHold', $ret['legal_hold']);
				}
				if (isset($ret['retention_min'])) {
					$xml->element('MinRetention', $ret['retention_min']);
				}
				if (isset($ret['retention_max'])) {
					$xml->element('MaxRetention', $ret['retention_max']);
				}
				$xml->pop(); //Retention
			}
		}
	}
}

function getInclusionExclusionXML($xml, $filenames, $xmlNodeName, $xmlElementName) {
	if ($filenames && count($filenames) > 0) {
		$xml->push($xmlNodeName);
		foreach ($filenames as $fileName) {
			// For Linux directories, remove the volume placeholder.
			$fileName = str_replace(LINUX_VOLUME, "", $fileName); 
			$xml->element($xmlElementName, $fileName);
		}
		$xml->pop(); // node
	}
}

$BP->destroyCookie();
?>