<?php
// defines BP, xml, action, cookie
require 'header.php';

$processInfo = array();

switch ($action) {				
	case "list":	// list all the current processs.
					$systemID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
					if (!isset($_GET['sid']) || $systemID == $BP->get_local_system_id()) {
						$processList = $BP->get_processes();
					} else {
						$processList = $BP->get_processes($systemID);
					}
					if ($processList == false) {
						$BP->buildResult($xml, false);
					} else {
						$xml->push('root');	
						displayProcessList($xml, $processList);
						$xml->pop();
					}
					echo($xml->getXml());
					break;
					
	case "kill":	// Kill specific process specified by its ID.
					if (isset($_GET['id'])) {
						$id = (int)$_GET['id'];				
						$systemID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
						if (!isset($_GET['sid']) || $systemID == $BP->get_local_system_id()) {
							$BP->buildResult($xml, $BP->terminate_process($id));
						} else {
							$BP->buildResult($xml, $BP->terminate_process($id, $systemID));
						}
						echo($xml->getXml());
					} else {
						$BP->buildResult($xml, false,
									"a process id must be specified to terminate a process.");
						echo($xml->getXml());
					}
					break;	
}

function displayProcessList($xml, $processList)
{
	foreach ($processList as $processInfo) {
		$processName = (array_key_exists('name', $processInfo)) ? $processInfo['name'] : "unknown";
		$processID = (array_key_exists('id', $processInfo)) ? $processInfo['id'] : "unknown";
		$xml->push("Process", array("Name" => $processName,
							 "ID" => $processID));
		if (array_key_exists('cpu', $processInfo))
			$xml->element('CPU', $processInfo['cpu']);
		if (array_key_exists('memory', $processInfo))
			$xml->element('Memory', $processInfo['memory']);
		if (array_key_exists('user', $processInfo))
			$xml->element('User', $processInfo['user']);
		if (array_key_exists('command', $processInfo))
			$xml->element('Command', $processInfo['command']);
		if (array_key_exists('comment', $processInfo))
			$xml->element('Comment', $processInfo['comment']);
		if (array_key_exists('bp', $processInfo))
			$xml->element('BP', $processInfo['bp'] == true ? "1" : "0");
		if (array_key_exists('kill', $processInfo))
			$xml->element('Kill', $processInfo['kill'] == true ? "1" : "0");
		$xml->pop(); // process
	}
}

$BP->destroyCookie();
?>