<?php
// defines BP, xml, action, cookie
require 'header.php';

// general backup list operations.
require 'listsbase.php';
$ListBase = new ListBase();

// xml reader operations for clients.
require 'xmlreader.php';

// Initialize variables to be used in copy and save.
$scheduleInfo = array();
$bValid = true;
$bCopy = false;

switch ($action) {

	case "list":
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			$xml->push('root');
			$ListBase->buildScheduleList($BP, $xml, $dpuID, false);
			$ListBase->buildAppScheduleList($BP, $xml, $dpuID);
			$ListBase->buildArchiveScheduleList($BP, $xml, $dpuID);
			$xml->pop(); // root
			echo($xml->getXml());
			break;
			
	case "all";
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			$xml->push('root');
			$ListBase->buildScheduleList($BP, $xml, $dpuID, false, true);
			$ListBase->buildAppScheduleList($BP, $xml, $dpuID);
			$ListBase->buildArchiveScheduleList($BP, $xml, $dpuID);
			$xml->pop(); // root
			echo($xml->getXml());
			break;
					
	case "load":
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();				
			if (($id = $ListBase->getID($BP, 'get_schedule_list', $dpuID)) == -1) {
				$BP->buildResult($xml, false, "Error: cannot find schedule for loading.");
			} else {
				$scheduleInfo = $BP->get_schedule_info($id, $dpuID);
				if ($scheduleInfo === false) {			
					$BP->buildResult($xml, false);
				} else {
					$xml->push("root");
					createScheduleXML($BP, $xml, $scheduleInfo, $dpuID, false);				
					$xml->pop(); // root
				}
			}
			echo($xml->getXml());
			break;
			
	case "copy":
			$bValid = false;
			$bCopy = true;
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			$originalID = (int)$_GET['oid'];	
			$scheduleList = $BP->get_schedule_list($dpuID);			
			if ($scheduleList === false) {
				$BP->buildResult($xml, false);
			} else {
				foreach ($scheduleList as $schedule) {
					if ($schedule['id'] == $originalID) {				
						$scheduleInfo = $BP->get_schedule_info($originalID, $dpuID);
						if ($scheduleInfo === false) {
							$BP->buildResult($xml, false);
						} else {
							$scheduleInfo = array_merge($schedule, $scheduleInfo);
							$bValid = true;
						}
						break;
					}
				}
			}		
			// Fall through to save the constructed schedule copy.
					
	case "save":
			if ($bValid) {
				$optionInfo = array();	
				$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
				$id = $ListBase->getID($BP, 'get_schedule_list', $dpuID);
				if ($id == -1) {
					if (isset($_GET['name'])) {
						$scheduleInfo = array_merge($scheduleInfo, array("name" => $_GET['name']));
					} else {
						$BP->buildResult($xml, false, "Error: must specify either name or id of schedule to save.");
						$bValid = false;
					}
				} else {
					$scheduleInfo = array_merge($scheduleInfo, array("id" => $_GET['id']));
					if (isset($_GET['name'])) {
						$scheduleInfo = array_merge($scheduleInfo, array("name" => $_GET['name']));
					}
				}
			}
			if ($bValid) {
				if ($bCopy) {
					unset($scheduleInfo['id']);
					$ListBase->buildResult($xml, $BP->save_schedule_info($scheduleInfo, $dpuID));
				} else {
					if (isset($_GET['desc'])) {
						$scheduleInfo['description'] = $_GET['desc'];
					}
					if (isset($_GET['enabled'])) {
						$enabled = $_GET['enabled'] == "1" ? true : false;
						$scheduleInfo['enabled'] = $enabled;
					}
					if (isset($_GET['cal'])) {
						$calendarID = (int)$_GET['cal'];
						$scheduleInfo['calendar'] = $calendarID;
					}
					if (isset($_REQUEST['clients'])) {
						$clientXML = $_REQUEST['clients'];
						$clients = xmlToClient($clientXML);
						$scheduleInfo['clients'] = $clients;			
					
						$optionList = array();
						$options = array ('before_command' => 'bcmd',
										  'after_command' => 'acmd');
						$bOptions = array('email_report' => 'email',
										  'failure_report' => 'fail',
										  'include_new' => 'inc');
						$optionList = buildOptions($optionList, $options, $bOptions);
					
						$scheduleInfo['options'] = $optionList;
		
						$ListBase->buildResult($xml, $BP->save_schedule_info($scheduleInfo, $dpuID));
					} else {
						$BP->buildResult($xml, false, "Error: must specify clients to save in schedule.");
					}
				}
			}
			echo($xml->getXml());			
			break;
				
	case "delete":
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			if (($id = $ListBase->getID($BP, 'get_schedule_list', $dpuID)) == -1) {
				$BP->buildResult($xml, false, "Error: cannot find identifier for deleting schedule.");
			} else {
				$BP->buildResult($xml, $BP->delete_schedule($id, $dpuID));
			}
			echo($xml->getXml());
			break;
			
	case "enable":
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			if (($id = $ListBase->getID($BP, 'get_schedule_list', $dpuID)) == -1) {
				$BP->buildResult($xml, false, "Error: cannot find identifier for enabling schedule.");
			} else {
				$BP->buildResult($xml, $BP->enable_schedule($id, $dpuID));
			}
			echo($xml->getXml());
			break;
			
	case "disable":
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			if (($id = $ListBase->getID($BP, 'get_schedule_list', $dpuID)) == -1) {
				$BP->buildResult($xml, false, "Error: cannot find identifier for disabling schedule.");
			} else {
				$BP->buildResult($xml, $BP->disable_schedule($id, $dpuID));
			}
			echo($xml->getXml());
			break;
			
	case "run":
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			if (($id = $ListBase->getID($BP, 'get_schedule_list', $dpuID)) == -1) {
				$BP->buildResult($xml, false, "Error: cannot find identifier for running schedule.");
			} else {
				$BP->buildResult($xml, $BP->schedule_now($id, $dpuID));
			}
			echo($xml->getXml());
			break;
}

//
// This function walks the schedule information returned from the load and creates the XML for each element.
//
function createScheduleXML($BP, $xml, $scheduleInfo, $dpuID, $bProduceScheduleWrapper = true)
{
	if ($bProduceScheduleWrapper) {
		$attributes = array("Name" => $scheduleInfo['name'],
							"ID" => $scheduleInfo['id'],
							"Enabled" => $scheduleInfo['enabled'] == true ? "1" : "0");
		if (array_key_exists('description', $scheduleInfo)) {
			$attributes = array_merge($attributes, array("Description" => $scheduleInfo['description']));
		}
		$xml->push("Schedule", $attributes);
	}

	$xml->element("CalendarID", $scheduleInfo['calendar']);	
	
	if (array_key_exists('clients', $scheduleInfo)) {
		$clientList = $scheduleInfo['clients'];
		foreach ($clientList as $client) {
			$xml->push("Client");
			$xml->element("ID", $client['id']);
			addClientInfo($xml, $client, "Inclusions", 'inclusions');
			addClientInfo($xml, $client, "Exclusions", 'exclusions');
			addClientInfo($xml, $client, "Options", 'options');
			$xml->pop(); // client
		}
	}
	
	if (array_key_exists('options', $scheduleInfo)) {
		$optionList = $scheduleInfo['options'];
		$xml->push("Options");
		global $ListBase;
		$ListBase->buildOptionsXML($xml, $optionList);
		$xml->pop(); // Options
	}
	
	if ($bProduceScheduleWrapper) {
		$xml->pop(); // Schedule
	}
}

//
// This function adds the client information to the XML content.
//
function addClientInfo($xml, $client, $stringTag, $stringField) {
	if (array_key_exists($stringField, $client)) {
		$listType = $client[$stringField];
		if (is_scalar($listType)) {
			$xml->element($stringTag, $listType);
		} else {
			$xml->push($stringTag);
			addSplit($xml, $listType);
			$xml->pop(); // inclusions, exclusions, options
		}
	}
}

//
// This function checks for split information in the clients (split per backup type)
// and adds it to the schedule information.
//
function addSplit($xml, $array) {
	if (array_key_exists('master', $array)) {
		$xml->element("Master", $array['master']);
	}
	if (array_key_exists('differential', $array)) {
		$xml->element("Differential", $array['differential']);
	}
	// map to differential.
	if (array_key_exists('incremental', $array)) {
		$xml->element("Differential", $array['incremental']);
	}
	/*
	if (array_key_exists('incremental', $array)) {
		$xml->element("Incremental", $array['incremental']);
	}
	*/
	if (array_key_exists('selective', $array)) {
		$xml->element("Selective", $array['selective']);
	}
	if (array_key_exists('baremetal', $array)) {
		$xml->element("BareMetal", $array['baremetal']);
	}
}

$BP->destroyCookie();
?>