<?php

define("WIR_UNITRENDS_APPLIANCE", "Unitrends appliance");
define("WIR_VMWARE_HOST", "VMware host");
define("WIR_HYPERV_HOST", "Hyper-V host");

// Possible values: Unitrends appliance, Hyper-V host and VMware host
// 
// If supported, returns the following format:
//		<Support WIRSupported="1">
//			<Type>Unitrends appliance</Type>
//			<Type>VMware host</Type>
//			<Type>Hyper-V host</Type>
//		</Support>
// If not supported, returns:
//		<Support WIRSupported="0" />
//
function createWIRSupportedXML($xml, $result) {
	// possible combinations
	//$result = array("Unitrends appliance", "Hyper-V host", "VMware host");
	//$result = array("Unitrends appliance", "VMware host");
	//$result = array("Unitrends appliance", "Hyper-V host");
	//$result = array("Hyper-V host", "VMware host");
	//$result = array("Unitrends appliance");
	//$result = array("VMware host");
	//$result = false;
	
	$value = $result == true ? "1" : "0";
	if ($result == true) {
		$xml->push('Support', array('WIRSupported'=>$value));
		foreach ($result as $supportedType) {
			$xml->element("Type", $supportedType);
		}
		$xml->pop(); // Support
	}
	else {
		$xml->emptyelement('WIRSupport', array('Supported'=>$value));
	}
}

function isWIROnApplianceSupported($result) {
	$ret = false;
	
	if ($result == true) {
		foreach ($result as $key=>$supportedType) {
			if ($supportedType != NULL && strlen(strstr( $supportedType, "Unitrends appliance" )) > 0 ) {
					$ret = true;
					break;
			}
		}
	}
	
	return $ret;
}

?>