<?php
//
// function getCustomerName
//
// Given an array of customers and ID, return the name for this ID.
//
// Parameters:	customers - array of customer names, indexed by ID.
//				customerID - ID of customer we are searching for.
//
// Returns;		customerName (string) or NULL if not found.
//
function getCustomerName($customers, $customerID)
{
	$customerName = NULL;
	
	foreach ($customers as $id => $name) {
		if ($id == $customerID) {
			$customerName = $name;
			break;
		}
	}
	return $customerName;
}

function getCustomerIDfromName($BP, $customerName)
{
	$customerID = -1;
	
	$customers = $BP->get_customer_list();
	foreach ($customers as $id => $name) {
		//printf("custIDfromname,%s, this name %s<br/>", $customerName, $name);
		if ($customerName == $name) {
			$customerID = $id;
			//printf("customer match found, id is %d<br/>", $customerID);
			break;
		}
	}
	return $customerID;
}

function getLocationIDFromName($BP, $locationName, $customerName)
{
	$locationID = -1;
	
	$customerID = getCustomerIDfromName($BP, $customerName);
	if ($customerID != -1) {
		$locations = $BP->get_location_list($customerID);
		foreach ($locations as $id => $name) {
			//printf("locationName = %s, name = %s,br/>", $locationName, $name);
			if ($locationName == $name) {
				$locationID = $id;
				//printf("location match found, id is %d<br/>", $locationID);
				break;
			}
		}
	}
	return $locationID;
}

function getSystemIDfromName($BP, $systemName)
{
	$systemID = -1;
	
	$systems = $BP->get_system_list();
	foreach ($systems as $id => $name) {
		if ($systemName == $name) {
			$systemID = $id;
			//printf("match found, id is %d<br/>", $customerID);
			break;
		}
	}
	return $systemID;
}


function getPrivilegeName($privilegeLevel)
{
	$privilegeName = NULL;
	switch ($privilegeLevel) {
		case 0: $privilegeName = "none"; break;
		case 1: $privilegeName = "monitor"; break;
		case 2: $privilegeName = "manage"; break;
		case 3: $privilegeName = "administer"; break;
		default: $privilegeName = "none"; break;
	}	
	return $privilegeName;
}

function getLocationName($locations, $locationID)
{
	$locationName = NULL;
	
	foreach ($locations as $id => $name) {
		if ($id == $locationID) {
			$locationName = $name;
			break;
		}
	}
	return $locationName;
}

function getSystemNameFromList($systems, $systemID)
{
	$systemName = NULL;
	
	foreach ($systems as $id => $name) {
		if ($id == $systemID) {
			$systemName = $name;
			break;
		}
	}
	return $systemName;
}

function matchLocation($location, $customerLocations)
{
	$bMatch = false;
	
	foreach ($customerLocations as $id => $name)
	{
		if ($location['id'] == $id) {
			$bMatch = true;
			break;
		}
	}
	return $bMatch;
}
function matchLocationName($locationName, $customerLocations)
{
	$bMatch = false;
	
	foreach ($customerLocations as $id => $name)
	{
		if ($locationName == $name) {
			$bMatch = true;
			break;
		}
	}
	return $bMatch;
}

class userInfo
{
	// LMC - for PHP 4 (mindAmplification.com) cannot use this.
	private $user = array();
	private $customerIndex = 0;
	private $locationIndex = 0;
	private $systemIndex = 0;
	/*
	var $user = array();
	var $customerIndex = 0;
	var $locationIndex = 0;
	var $systemIndex = 0;
	*/
	
	// lmc - php5 constructors have different names
	//function userInfo($name = NULL, $password = NULL)
	//if (is_php5())
	function __construct($name = NULL, $password = NULL)
	{
		$args = func_num_args();
		if ($args == 2) {
			$this->user['id'] = -1;
			$this->user['name'] = $name;
			$this->user['password'] = $password;
			$this->user['superuser'] = false;
		} else {
			$this->user = $name;
		}
	}
	
	function setName($name)
	{
		$this->user['name'] = $name;
	}
	
	function setPassword($password)
	{
		$this->user['password'] = $password;
	}
	
	function setPrivileges()
	{
	}
	
	function getInfo()
	{
		return $this->user;
	}
	
	function setSuperUser($superuser)
	{
		$this->user['superuser'] = $superuser;
	}
	
	function getPrivilege($privilegeString)
	{
		$privilege = 0;
		switch ($privilegeString) {
			case 'None':	$privilege = 0; break;
			case 'Monitor':	$privilege = 1; break;
			case 'Manage':	$privilege = 2; break;
			case 'Admin':	$privilege = 3; break;
		}
		return $privilege;
	}
	
	function setCustomerPrivilege($privilegeString, $customerID)
	{
		$privilege = $this->getPrivilege($privilegeString);
		$this->user['customers'][$this->customerIndex]['id'] = $customerID;
		$this->user['customers'][$this->customerIndex]['privilege_level'] = $privilege;
		$this->customerIndex++;
	}
	
	function setLocationPrivilege($privilegeString, $locationID)
	{
		$privilege = $this->getPrivilege($privilegeString);
		$this->user['locations'][$this->locationIndex]['id'] = $locationID;
		$this->user['locations'][$this->locationIndex]['privilege_level'] = $privilege;
		$this->locationIndex++;
	}
	
	function setSystemPrivilege($privilegeString, $systemID)
	{
		$privilege = $this->getPrivilege($privilegeString);
		$this->user['systems'][$this->systemIndex]['id'] = $systemID;
		$this->user['systems'][$this->systemIndex]['privilege_level'] = $privilege;
		$this->systemIndex++;
	}
}

function matchSystem($system, $customerLocationSystems)
{
	$bMatch = false;
	
	foreach ($customerLocationSystems as $id => $name)
	{
		if ($system['id'] == $id) {
			$bMatch = true;
			break;
		}
	}
	return $bMatch;
}

function matchSystemName($systemName, $customerLocationSystems)
{
	$bMatch = false;
	
	foreach ($customerLocationSystems as $id => $name)
	{
		if ($systemName == $name) {
			$bMatch = true;
			break;
		}
	}
	return $bMatch;
}

function getPrivilegeText($userInfo)
{
	$text = NULL;
	
	// get complete list of customers, locations and systems. (Need to preface with bp_set_cookie().
	global $BP;
	$customers = $BP->get_customer_list();
	$locations = $BP->get_location_list();
	$systems = $BP->get_system_list();
	
	if (array_key_exists('customers', $userInfo)) {
		foreach ($userInfo['customers'] as $customer) {
			// Display customer-level privileges for this user.
			$text .= sprintf("customer %s (%s)<br/>",
					getCustomerName($customers, $customer['id']),
					getPrivilegeName($customer['privilege_level']));
			
			// Get locations for this customer.
			$customerLocations = $BP->get_location_list($customer['id']);
			if (array_key_exists('locations', $userInfo)) {
				foreach ($userInfo['locations'] as $location) {
			
					// If any specified location-level privileges matches this customer's locations,
					// display name, location, and  privileges.
					if (matchLocation($location, $customerLocations)) {
						$text .= sprintf("customer %s, location %s (%s)<br/>",
							getCustomerName($customers, $customer['id']), 
							getLocationName($locations, $location['id']),
							getPrivilegeName($location['privilege_level']));
								
						// Get systems for this customer at this location.	
						$customerLocationSystems = $BP->get_system_list($customer['id'], $location['id']);
						if (array_key_exists('systems', $userInfo)) {
							foreach ($userInfo['systems'] as $system) {
					
								// If any specified system-level privileges matches this customer's locations/systems,
								// display name, location, system and privileges.
								if (matchSystem($system, $customerLocationSystems)) {
									$text .= sprintf("customer %s, location %s, system %s (%s)<br/>",
										getCustomerName($customers, $customer['id']),
										getLocationName($locations, $location['id']),
										getSystemName($systems, $system['id']),
										getPrivilegeName($system['privilege_level']));
								}
							}
						}
					}
				}
			}
		}
	}
	return $text;					
}

class locationInfo
{
	private $location = array();
		
	// php5 function constructors are different
	// php5 function constructors are different
	// function locationInfo($name, $latitude, $longitude)
	//if (is_php5()) {
	function __construct($name, $latitude, $longitude)
	{
		$this->location['id'] = -1;
		$this->location['name'] = $name;
		$this->location['latitude'] = (double)$latitude;
		$this->location['longitude'] = (double)$longitude;
	}
	
	function setCustomerID($id)
	{
		$this->location['customer_id'] = $id;
	}
	
	function setCustomerName($name)
	{
		$this->location['customer_name'] = $name;
	}
	
	function getInfo()
	{
		return $this->location;
	}
}

class customerInfo
{
	private $customer = array();
		
	// php5 function constructors are different
	// 	function customerInfo($name)
	//if (is_php5()) {
	function __construct($name)
	{
		$this->customer['id'] = -1;
		$this->customer['name'] = $name;
	}
	
	function getInfo()
	{
		return $this->customer;
	}
}


?>
