<?php
// defines BP, xml, action, cookie
require 'header.php';

// wir supported utility
require $rootdir . 'bpl/tools/wir_supported_util.php';

global $Log;
$networkInfo = array();

// get system ID.
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

switch ($action) {
	case "getnwk":
			// get virtual bridge network
			// First see if the feature is supported.
			$virtual_clients_supported = $BP->virtual_clients_supported($dpuID);
			if ($virtual_clients_supported !== -1) {
				// We were able to successfully determine feature status
				$xml->push("root");
				$wirOnApplianceSupported = isWIROnApplianceSupported($virtual_clients_supported);
				if ($wirOnApplianceSupported) {
					// If WIR on appliance supported, get the virtual bridge network information.
					$networks = $BP->get_virtual_bridge_network($dpuID);
					$xml->element('Network',   $networks['NETWORK']);
					$xml->element('Netmask',   $networks['NETMASK']);
					$xml->element('Gateway',   $networks['GATEWAY']);
					$xml->element('DHCPRange', $networks['DHCPRANGE']);
				} else {
					// If not supported, indicate as such
					// (only output Support if WIR on appliance not supported)
					$Support = $wirOnApplianceSupported == true ? "1" : "0";
					$xml->element('Support', $Support);
				}
				$xml->pop();	// root
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
					
	case "get":
			// get virtual bridge				
			$virtualBridges = $BP->get_virtual_bridge($dpuID);		
			if ($virtualBridges !== false) {
				$xml->push("root");	
				if ($virtual_client_result !== -1) {
					foreach ($virtualBridges as $virtualBridge) {
						$xml->element('Result', $virtualBridge);
					}
				} 
				$xml->pop(); //root
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
					
	case "set":
			// set virtual network
			$sNic = $_GET['nic_name'];
			$setVirtualNetworkResult = $BP->set_virtual_bridge($sNic, $dpuID);
			if ($setVirtualNetworkResult > 0) {
				$xml->push("root");
				$xml->element('Result', $setVirtualNetworkResult);
				$xml->pop(); //root
			} else {
				$xml->push("root");
				$xml->element('Result', bp_error());
				$xml->pop(); //root
			}
			echo($xml->getXml());
			break;
					
	case "delete":
			// delete virtual bridge
			$sBridge = $_GET['bdg_name'];
			$sNic = $_GET['nic_name'];
			$BP->buildResult($xml, $BP->delete_virtual_bridge($sBridge, $sNic, $dpuID));
			echo($xml->getXml());
			break;
						
	case "add":
			// add virtual bridge
			$sNic = $_GET['nic_name'];
			$addBridgeResult = $BP->add_virtual_bridge($sNic, $dpuID);
			if ($addBridgeResult !== false) {
				$xml->push("root");
				$xml->element('Result', $addBridgeResult[0]);
				$xml->pop(); //root
			} else {
				$BP->buildResult($xml, false);
			}	
			echo($xml->getXml());
			break;

}

$BP->destroyCookie();
?>
